
/*
 *  Ump - Unnamed Math Program
 *  Copyright (c) 2004-2006 by Mattias Hultgren <mattias_hultgren@tele2.se>
 *
 *  See main.cpp
 */

#include "gradient_editor.h"
#include "picture2gtk.h"
#include "math2.h"

const int32 GRADIENT_PICTURE_WIDTH  = 100;
const int32 GRADIENT_PICTURE_HEIGHT = 200;

int active_color;
picture2gtk gradient_picture;
Vector<picture_h::colorrgb> working_gradient;
GtkWidget *the_parent;

void gradient_update_color(void);

void gradient_select_color( const picture2gtk *src, int32 x, int32 y, int32 button);

void gradient_change_color(GtkButton *button, gpointer user_data);
void gradient_add_color(GtkButton *button, gpointer user_data);
void gradient_remove_color(GtkButton *button, gpointer user_data);
void gradient_move_up(GtkButton *button, gpointer user_data);
void gradient_move_down(GtkButton *button, gpointer user_data);

void gradient_editor( GtkWidget *parent, Vector<picture_h::colorrgb> &gradient ) throw(error_obj)
{
	GtkWidget *dialog, *box, *box2, *button, *drawarea;

	dialog = gtk_dialog_new_with_buttons( _("Gradient editor"), GTK_WINDOW(parent),
	                                      GtkDialogFlags(GTK_DIALOG_DESTROY_WITH_PARENT | GTK_DIALOG_MODAL),
	                                      GTK_STOCK_OK, GTK_RESPONSE_ACCEPT,
	                                      NULL );
	the_parent = dialog;

	working_gradient = gradient;

	box = gtk_hbox_new( FALSE, 3 );
	gtk_container_set_border_width( GTK_CONTAINER(box), 3 );
	gtk_box_pack_start( GTK_BOX( GTK_DIALOG(dialog)->vbox), box, FALSE, FALSE, 3 );

	active_color = gradient.get_size() -1;

	gradient_picture.set_size( GRADIENT_PICTURE_WIDTH, GRADIENT_PICTURE_HEIGHT );

	gradient_update_color();
	drawarea = gtk_drawing_area_new();
	gradient_picture.connect_to_drawing_area( drawarea );

	gradient_picture.mousedown_func = gradient_select_color;

	gtk_box_pack_start( GTK_BOX(box), drawarea, FALSE, FALSE, 0 );


	box2 = gtk_vbox_new( TRUE, 0 );
	gtk_box_pack_start( GTK_BOX(box), box2, FALSE, FALSE, 0 );


	{
		GtkWidget *tmp_hbox;

		button = gtk_button_new();
		gtk_box_pack_start( GTK_BOX(box2), button, FALSE, FALSE, 0 );
		tmp_hbox = gtk_hbox_new( FALSE, 0 );
		gtk_container_add( GTK_CONTAINER(button), tmp_hbox );
		gtk_box_pack_start( GTK_BOX(tmp_hbox), gtk_image_new_from_stock( GTK_STOCK_SELECT_COLOR, GTK_ICON_SIZE_BUTTON ),
		                    FALSE, FALSE, 0 );
		gtk_box_pack_start( GTK_BOX(tmp_hbox), gtk_label_new( _("Change color") ), FALSE, FALSE, 0 );
		g_signal_connect( GTK_OBJECT(button), "clicked", G_CALLBACK(gradient_change_color), NULL );


		button = gtk_button_new();
		gtk_box_pack_start( GTK_BOX(box2), button, FALSE, FALSE, 0 );
		tmp_hbox = gtk_hbox_new( FALSE, 0 );
		gtk_container_add( GTK_CONTAINER(button), tmp_hbox );
		gtk_box_pack_start( GTK_BOX(tmp_hbox), gtk_image_new_from_stock( GTK_STOCK_ADD, GTK_ICON_SIZE_BUTTON ),
		                    FALSE, FALSE, 0 );
		gtk_box_pack_start( GTK_BOX(tmp_hbox), gtk_label_new( _("Add color") ), FALSE, FALSE, 0 );
		g_signal_connect( GTK_OBJECT(button), "clicked", G_CALLBACK(gradient_add_color), NULL );


		button = gtk_button_new();
		gtk_box_pack_start( GTK_BOX(box2), button, FALSE, FALSE, 0 );
		tmp_hbox = gtk_hbox_new( FALSE, 0 );
		gtk_container_add( GTK_CONTAINER(button), tmp_hbox );
		gtk_box_pack_start( GTK_BOX(tmp_hbox), gtk_image_new_from_stock( GTK_STOCK_REMOVE, GTK_ICON_SIZE_BUTTON ),
		                    FALSE, FALSE, 0 );
		gtk_box_pack_start( GTK_BOX(tmp_hbox), gtk_label_new( _("Remove color") ), FALSE, FALSE, 0 );
		g_signal_connect( GTK_OBJECT(button), "clicked", G_CALLBACK(gradient_remove_color), NULL );


		button = gtk_button_new();
		gtk_box_pack_start( GTK_BOX(box2), button, FALSE, FALSE, 0 );
		tmp_hbox = gtk_hbox_new( FALSE, 0 );
		gtk_container_add( GTK_CONTAINER(button), tmp_hbox );
		gtk_box_pack_start( GTK_BOX(tmp_hbox), gtk_image_new_from_stock( GTK_STOCK_GO_UP, GTK_ICON_SIZE_BUTTON ),
		                    FALSE, FALSE, 0 );
		gtk_box_pack_start( GTK_BOX(tmp_hbox), gtk_label_new( _("Move up") ), FALSE, FALSE, 0 );
		g_signal_connect( GTK_OBJECT(button), "clicked", G_CALLBACK(gradient_move_up), NULL );


		button = gtk_button_new();
		gtk_box_pack_start( GTK_BOX(box2), button, FALSE, FALSE, 0 );
		tmp_hbox = gtk_hbox_new( FALSE, 0 );
		gtk_container_add( GTK_CONTAINER(button), tmp_hbox );
		gtk_box_pack_start( GTK_BOX(tmp_hbox), gtk_image_new_from_stock( GTK_STOCK_GO_DOWN, GTK_ICON_SIZE_BUTTON ),
		                    FALSE, FALSE, 0 );
		gtk_box_pack_start( GTK_BOX(tmp_hbox), gtk_label_new( _("Move down") ), FALSE, FALSE, 0 );
		g_signal_connect( GTK_OBJECT(button), "clicked", G_CALLBACK(gradient_move_down), NULL );
	}

	gtk_widget_show_all(dialog);
	if( gtk_dialog_run( GTK_DIALOG(dialog) ) == GTK_RESPONSE_ACCEPT )
		gradient = working_gradient;

	gtk_widget_destroy(dialog);
}

void gradient_update_color(void)
{
	for( int32 i=0; i<gradient_picture.get_height(); i++ )
	{
		picture_h::colorrgb tmp_color;
		math::color_list_get_color( working_gradient, 0.0, floatx(gradient_picture.get_height()-1),
		                            floatx(gradient_picture.get_height()-1-i), &tmp_color );
		gradient_picture.line( 0, i, gradient_picture.get_width()-1, i, tmp_color );
	}

	if( active_color >= working_gradient.get_size() )
		active_color = working_gradient.get_size() -1;

	if( working_gradient.get_size() > 1 )
	{
		int32 middle = int32( (1.0- float(active_color) / float(working_gradient.get_size() -1) ) *
		                      float(gradient_picture.get_height()) );

		if( active_color == 0 )
			middle -= 7;
		if( active_color == (working_gradient.get_size() -1) )
			middle += 6;

		gradient_picture.box( 0, middle -6, gradient_picture.get_width(), 13, picture_h::color::WHITE );
		gradient_picture.box( 1, middle -5, gradient_picture.get_width() -2, 11, picture_h::color::BLACK );
		gradient_picture.box( 2, middle -4, gradient_picture.get_width() -4, 9, picture_h::color::WHITE );
	}

	gradient_picture.update();
}

void gradient_select_color( const picture2gtk *src, int32 x, int32 y, int32 button)
{
	if( button == 1 ) // left button
	{
		if( y < 0 )
			y = 0;
		if( y >= gradient_picture.get_height() )
			y = gradient_picture.get_height() -1;

		active_color = int32( (1.0 - float(y) / float(gradient_picture.get_height() -1) ) *
		                      float(working_gradient.get_size() -1) + 0.5f);
		gradient_update_color();
	}
}

void gradient_change_color(GtkButton *button, gpointer user_data)
{
	GtkColorSelectionDialog *colordialog;
	GdkColor color;

	colorrgb_to_gdkcolor( *working_gradient[active_color], color );

	colordialog = (GtkColorSelectionDialog *) gtk_color_selection_dialog_new(NULL);

	gtk_color_selection_set_current_color( GTK_COLOR_SELECTION(colordialog->colorsel), &color );

	gtk_window_set_transient_for( GTK_WINDOW(colordialog), GTK_WINDOW(the_parent) );
	gtk_window_set_modal( GTK_WINDOW(colordialog), TRUE );

	gtk_widget_show_all( GTK_WIDGET(colordialog) );

	gtk_widget_hide(colordialog->help_button);

	if( gtk_dialog_run( GTK_DIALOG(colordialog) ) == GTK_RESPONSE_OK )
	{
		picture_h::colorrgb colorr;

		gtk_color_selection_get_current_color( GTK_COLOR_SELECTION(GTK_COLOR_SELECTION_DIALOG(colordialog)->colorsel), &color );
		gdkcolor_to_colorrgb( color, colorr );
		*working_gradient[active_color] = colorr;
		gradient_update_color();
	}
	gtk_widget_destroy( GTK_WIDGET(colordialog) );
}

void gradient_add_color(GtkButton *button, gpointer user_data)
{
	GtkColorSelectionDialog *colordialog;
	GdkColor color;

	colorrgb_to_gdkcolor( *working_gradient[active_color], color );

	colordialog = (GtkColorSelectionDialog *) gtk_color_selection_dialog_new(NULL);

	gtk_color_selection_set_current_color( GTK_COLOR_SELECTION(colordialog->colorsel), &color );

	gtk_window_set_transient_for( GTK_WINDOW(colordialog), GTK_WINDOW(the_parent) );
	gtk_window_set_modal( GTK_WINDOW(colordialog), TRUE );

	gtk_widget_show_all( GTK_WIDGET(colordialog) );

	gtk_widget_hide(colordialog->help_button);

	if( gtk_dialog_run( GTK_DIALOG(colordialog) ) == GTK_RESPONSE_OK )
	{
		picture_h::colorrgb colorr;

		gtk_color_selection_get_current_color( GTK_COLOR_SELECTION(GTK_COLOR_SELECTION_DIALOG(colordialog)->colorsel), &color );
		gdkcolor_to_colorrgb( color, colorr );
		working_gradient.insert( colorr, active_color );
		gradient_update_color();
	}
	gtk_widget_destroy( GTK_WIDGET(colordialog) );
}

void gradient_remove_color(GtkButton *button, gpointer user_data)
{
	if( working_gradient.get_size() > 1 )
	{
		working_gradient.remove( active_color );
		gradient_update_color();
	}
}

void gradient_move_up(GtkButton *button, gpointer user_data)
{
	if( active_color != (working_gradient.get_size() -1) )
	{
		picture_h::colorrgb color;

		color = *working_gradient[active_color];
		*working_gradient[active_color] = *working_gradient[active_color +1];
		*working_gradient[active_color +1] = color;
		active_color++;
		gradient_update_color();
	}
}

void gradient_move_down(GtkButton *button, gpointer user_data)
{
	if( active_color != 0 )
	{
		picture_h::colorrgb color;

		color = *working_gradient[active_color];
		*working_gradient[active_color] = *working_gradient[active_color -1];
		*working_gradient[active_color -1] = color;
		active_color--;
		gradient_update_color();
	}
}
