
/*
 *  Ump - Unnamed Math Program
 *  Copyright (c) 2004-2006 by Mattias Hultgren <mattias_hultgren@tele2.se>
 *
 *  See main.cpp
 */

#include <gtk/gtk.h>
#include <math.h>
#include <string.h>
#include <stdlib.h>
#include "ump_graphwin.h"
#include "ump_editor.h"
#include "ump_simplewin.h"
#include "ump_aboutwin.h"
#include "ump_picturewin.h"
#include "ump_advancedwin.h"
#include "ump_prefwin.h"
#include "matrix_editor.h"
#include "picture.h"
#include "picture2gtk.h"
#include "main.h"
#include "gradient_editor.h"

#define GET_BOOLEAN_KEY( KEY, DEST )    if((str = setup_file.get_key( KEY )) != 0) \
                                        { \
                                          if( *str == "True" ) \
                                            DEST = true; \
                                          else if( *str == "False" ) \
                                            DEST = false; \
                                          else \
                                          { \
                                            char tmp_err[ERROR_OBJ_MSG_LEN]; \
                                            snprintf( tmp_err, ERROR_OBJ_MSG_LEN, _("Invalid format in file %s"), "<Configure file>" ); \
                                            THROW_ERROR( ErrorType_File_IO, tmp_err ); \
                                          } \
                                        }


void graphwin_settings_show(void);


graph_settings settings;


GtkWidget *graphwin = 0, *graphwin_vbox, *graphwin_vbox_top, *graphwin_menu, *graphwin_plot_frame;
GtkWidget *spinwidth,*spinheight,*entryxmin,*entryxmax,*entryymin,*entryymax;
GtkWidget *notebook, *checkaxes, *checkgrid;
#ifdef PLOT_3D
	GtkWidget *notebook_2d_3d, *graphwin_3d_frame, *graphwin_3d_width_label;
	GtkWidget *graphwin_3d_height_label, *graphwin_3d_width, *graphwin_3d_height;
	GtkWidget *graphwin_3d_xmin_label, *graphwin_3d_xmax_label, *graphwin_3d_xsteps_label;
	GtkWidget *graphwin_3d_ymin_label, *graphwin_3d_ymax_label, *graphwin_3d_ysteps_label;
	GtkWidget *graphwin_3d_zmin_label, *graphwin_3d_zmax_label;
	GtkWidget *graphwin_3d_xmin, *graphwin_3d_xmax, *graphwin_3d_xsteps;
	GtkWidget *graphwin_3d_ymin, *graphwin_3d_ymax, *graphwin_3d_ysteps;
	GtkWidget *graphwin_3d_zmin, *graphwin_3d_zmax;
	GtkWidget *graphwin_3d_notebook, *graphwin_buttonlabel_3d_draw;
#endif
GtkWidget *graphwin_width, *graphwin_height, *graphwin_xmin, *graphwin_xmax, *graphwin_ymin, *graphwin_ymax;
GtkWidget *graphwin_buttonlabel_settings, *graphwin_polar_start, *graphwin_polar_stop, *graphwin_polar_steps;
GtkWidget *graphwin_buttonlabel_draw, *graphwin_para_start, *graphwin_para_stop, *graphwin_para_steps;

GtkWidget *polarentrystart, *polarentrystop, *polarentrystep;
GtkWidget *parentrystart, *parentrystop, *parentrystep;
const gint max_len_entry = 100;

#ifdef PLOT_3D
	#define PLOT_3D_FUNCTIONS 5
#endif

struct bunch
{
	picture2gtk colorpic;
	GtkWidget *check,*entry,*entry2,*button;
#ifdef PLOT_3D
	GtkWidget *combo;
}func[10], polar[10], par[5], func_3d[PLOT_3D_FUNCTIONS];
Vector<picture_h::colorrgb> func_3d_colors[PLOT_3D_FUNCTIONS];
#else
}func[10], polar[10], par[5];
#endif


void aboutwin_show_graphtool(void) { aboutwin_show(GTK_WINDOW(graphwin)); }
void prefwin_show_graphtool(void) { prefwin_show(GTK_WINDOW(graphwin)); }



void drawbutton_click(GtkButton *button,gpointer user_data);


void colordialogcancel(GtkButton *button,gpointer user_data)
{
	GtkWidget *dialog = gtk_widget_get_toplevel(GTK_WIDGET(button));

	if(GTK_WIDGET_TOPLEVEL(dialog))
		gtk_widget_destroy(GTK_WIDGET(dialog));
}

void colordialogok(GtkButton *button,gpointer user_data)
{
	GtkWidget *dialog = gtk_widget_get_toplevel(GTK_WIDGET(button));

	if(GTK_WIDGET_TOPLEVEL(dialog))
	{
		if(graphwin == 0)
			gtk_widget_destroy(GTK_WIDGET(dialog));

		GdkColor color;
		gtk_color_selection_get_current_color(
		  GTK_COLOR_SELECTION(GTK_COLOR_SELECTION_DIALOG(dialog)->colorsel), &color );
		{
			picture2gtk *tmp = (picture2gtk *) user_data;
			picture_h::colorrgb colorr;

			gdkcolor_to_colorrgb( color, colorr );

			tmp->clear(colorr);
			tmp->update();
		}

		gtk_widget_destroy(GTK_WIDGET(dialog));
	}
}

void colorbutton_click(GtkButton *button,gpointer user_data)
{
	GtkColorSelectionDialog *colordialog;
	GdkColor color;

	colorrgb_to_gdkcolor( ((picture2gtk *) user_data)->get_pixel(0,0), color );

	colordialog = (GtkColorSelectionDialog *) gtk_color_selection_dialog_new(NULL);

	gtk_color_selection_set_current_color(GTK_COLOR_SELECTION(colordialog->colorsel),&color);

	g_signal_connect( GTK_OBJECT(colordialog->ok_button), "clicked", G_CALLBACK(colordialogok),
	                  user_data);

	g_signal_connect( GTK_OBJECT(colordialog->cancel_button), "clicked",
	                  G_CALLBACK(colordialogcancel), user_data );

	gtk_window_set_transient_for( GTK_WINDOW(colordialog), GTK_WINDOW(graphwin) );
	gtk_window_set_modal( GTK_WINDOW(colordialog), TRUE );

	gtk_widget_show_all( GTK_WIDGET(colordialog) );

	gtk_widget_hide(colordialog->help_button);
}

void drawbutton_click(GtkButton *button,gpointer user_data)
{
	try
	{
		settings.width =  gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(spinwidth));
		settings.height = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(spinheight));
		settings.xmin = gtk_entry_get_text(GTK_ENTRY(entryxmin));
		settings.xmax = gtk_entry_get_text(GTK_ENTRY(entryxmax));
		settings.ymin = gtk_entry_get_text(GTK_ENTRY(entryymin));
		settings.ymax = gtk_entry_get_text(GTK_ENTRY(entryymax));

		settings.grid_on = (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(checkgrid)) == TRUE) ? true : false;

		settings.axes_on = (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(checkaxes)) == TRUE) ? true : false;

		settings.active_page = gtk_notebook_get_current_page(GTK_NOTEBOOK(notebook));

		for(int i=0;i<10;i++) // setting up all functions
		{
			settings.func[i].entry = gtk_entry_get_text(GTK_ENTRY(func[i].entry));
			settings.func[i].color = func[i].colorpic.get_pixel(0,0);
			settings.func[i].show_this = (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(func[i].check)) == TRUE) ? true : false;

			settings.polar[i].entry = gtk_entry_get_text(GTK_ENTRY(polar[i].entry));
			settings.polar[i].color = polar[i].colorpic.get_pixel(0,0);
			settings.polar[i].show_this = (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(polar[i].check)) == TRUE) ? true : false;

			if(i < 5)
			{
				settings.par[i].entry = gtk_entry_get_text(GTK_ENTRY(par[i].entry));
				settings.par[i].entry2 = gtk_entry_get_text(GTK_ENTRY(par[i].entry2));
				settings.par[i].color = par[i].colorpic.get_pixel(0,0);
				settings.par[i].show_this = (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(par[i].check)) == TRUE) ? true : false;
			}
		}
		settings.polar_start = gtk_entry_get_text(GTK_ENTRY(polarentrystart));
		settings.polar_stop = gtk_entry_get_text(GTK_ENTRY(polarentrystop));
		settings.polar_steps = gtk_entry_get_text(GTK_ENTRY(polarentrystep));

		settings.par_start = gtk_entry_get_text(GTK_ENTRY(parentrystart));
		settings.par_stop = gtk_entry_get_text(GTK_ENTRY(parentrystop));
		settings.par_steps = gtk_entry_get_text(GTK_ENTRY(parentrystep));
	}
	catch(error_obj error)
	{
		(*TEXTVIEW_FUNCTION)(error.msg);
		(*TEXTVIEW_FUNCTION)("\n");
	}

	picturewin_show( &settings );
}

void entry_insert(GtkEditable *editable, gchar *new_text, gint new_text_length, gint *position)
{
	for(gint i=0;i<new_text_length;i++)
	{
		if(new_text[i] == '\"')
			new_text[i] = ' ';
	}
}
void entry_changed(GtkEditable *editable,gpointer user_data)
{
	bunch *tmp;
	const gchar *str;
	bool empty = true, empty2 = false;

	tmp = (bunch *) user_data;

	str = gtk_entry_get_text(GTK_ENTRY(tmp->entry));

	if(str != 0)
	{
		for(int i=0;str[i] != 0;i++)
		{
			if(str[i] != ' ')
			{
				empty = false;
				break;
			}
		}
	}

	if(tmp->entry2 != 0)
	{
		empty2 = true;
		str = gtk_entry_get_text(GTK_ENTRY(tmp->entry2));

		if(str != 0)
		{
			for(int i=0;str[i] != 0;i++)
			{
				if(str[i] != ' ')
				{
					empty2 = false;
					break;
				}
			}
		}
	}

	if( empty == true  ||  empty2 == true )
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(tmp->check),FALSE);
	else
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(tmp->check),TRUE);
}
void checkbox_toggled(GtkToggleButton *togglebutton, gpointer user_data)
{
	bunch *tmp;
	const gchar *str;
	bool empty = true, empty2 = false;

	if(gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON(togglebutton) ) == FALSE)
		return;

	tmp = (bunch *) user_data;

	str = gtk_entry_get_text(GTK_ENTRY(tmp->entry));

	if(str != 0)
	{
		for(int i=0;str[i] != 0;i++)
		{
			if(str[i] != ' ')
			{
				empty = false;
				break;
			}
		}
	}

	if(tmp->entry2 != 0)
	{
		empty2 = true;
		str = gtk_entry_get_text(GTK_ENTRY(tmp->entry2));

		if(str != 0)
		{
			for(int i=0;str[i] != 0;i++)
			{
				if(str[i] != ' ')
				{
					empty2 = false;
					break;
				}
			}
		}
	}

	if(empty == true  ||  empty2 == true)
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(togglebutton),FALSE);
	else
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(togglebutton),TRUE);
}

#ifdef PLOT_3D
void gradientbutton_click(GtkButton *button,gpointer user_data)
{
	int i = GPOINTER_TO_INT(user_data);

	gradient_editor( graphwin, func_3d_colors[i] );

	for( int32 i2=0; i2<45; i2++ )
	{
		picture_h::colorrgb tmp_color;
		math::color_list_get_color( func_3d_colors[i], 0.0, 44.0, floatx(44-i2), &tmp_color );
		func_3d[i].colorpic.line( 0, i2, 18, i2, tmp_color );
	}
	func_3d[i].colorpic.update();
}

void drawbutton_3d_click(GtkButton *button,gpointer user_data)
{
	utf8_string str;
	math::CodeLine function;

	try
	{
		if( settings.show_code )
			(*TEXTVIEW_FUNCTION)( "_3d_clear\n" );
		function.set_code_line( "_3d_clear\n" );
		function.calc( 0 );

		str = "_3d_set_prop( \"Width\", ";
		str.append( gtk_entry_get_text( GTK_ENTRY(graphwin_3d_width) ) );
		str.append( ", \"Height\", " );
		str.append( gtk_entry_get_text( GTK_ENTRY(graphwin_3d_height) ) );
		str.append( ", \"Look at\", [[ ((" );
		str.append( gtk_entry_get_text( GTK_ENTRY(graphwin_3d_xmin) ) );
		str.append( ")+(" );
		str.append( gtk_entry_get_text( GTK_ENTRY(graphwin_3d_xmax) ) );
		str.append( "))/2 ][ ((" );
		str.append( gtk_entry_get_text( GTK_ENTRY(graphwin_3d_ymin) ) );
		str.append( ")+(" );
		str.append( gtk_entry_get_text( GTK_ENTRY(graphwin_3d_ymax) ) );
		str.append( "))/2 ][ ((" );
		str.append( gtk_entry_get_text( GTK_ENTRY(graphwin_3d_zmin) ) );
		str.append( ")+(" );
		str.append( gtk_entry_get_text( GTK_ENTRY(graphwin_3d_zmax) ) );
		str.append( "))/2 ]], \"Camera distance\", sqrt( |(" );
		str.append( gtk_entry_get_text( GTK_ENTRY(graphwin_3d_xmin) ) );
		str.append( ")-(" );
		str.append( gtk_entry_get_text( GTK_ENTRY(graphwin_3d_xmax) ) );
		str.append( ")|^2 + |(" );
		str.append( gtk_entry_get_text( GTK_ENTRY(graphwin_3d_ymin) ) );
		str.append( ")-(" );
		str.append( gtk_entry_get_text( GTK_ENTRY(graphwin_3d_ymax) ) );
		str.append( ")|^2 + |(" );
		str.append( gtk_entry_get_text( GTK_ENTRY(graphwin_3d_zmin) ) );
		str.append( ")-(" );
		str.append( gtk_entry_get_text( GTK_ENTRY(graphwin_3d_zmax) ) );
		str.append( ")|^2 ) )" );
		if( settings.show_code )
		{
			(*TEXTVIEW_FUNCTION)( str );
			(*TEXTVIEW_FUNCTION)( "\n" );
		}
		function.set_code_line( str.c_str() );
		function.calc( 0 );

		str = "plot_x_matrix = table( \"x\", x, dec( ";
		str.append( gtk_entry_get_text( GTK_ENTRY(graphwin_3d_xmin) ) );
		str.append( " ), dec( " );
		str.append( gtk_entry_get_text( GTK_ENTRY(graphwin_3d_xmax) ) );
		str.append( " ), " );
		str.append( gtk_entry_get_text( GTK_ENTRY(graphwin_3d_xsteps) ) );
		str.append( " )" );
		if( settings.show_code )
		{
			(*TEXTVIEW_FUNCTION)( str );
			(*TEXTVIEW_FUNCTION)( "\n" );
		}
		function.set_code_line( str.c_str() );
		function.calc( 0 );

		str = "plot_y_matrix = table( \"y\", y, dec( ";
		str.append( gtk_entry_get_text( GTK_ENTRY(graphwin_3d_ymin) ) );
		str.append( ") , dec( " );
		str.append( gtk_entry_get_text( GTK_ENTRY(graphwin_3d_ymax) ) );
		str.append( " ) , " );
		str.append( gtk_entry_get_text( GTK_ENTRY(graphwin_3d_ysteps) ) );
		str.append( " )" );
		if( settings.show_code )
		{
			(*TEXTVIEW_FUNCTION)( str );
			(*TEXTVIEW_FUNCTION)( "\n" );
		}
		function.set_code_line( str.c_str() );
		function.calc( 0 );

		for( int i=0; i<PLOT_3D_FUNCTIONS; i++ ) // setting up all functions
		{
			char number[3] = "z0";

			number[1] = '0' + i;
			str = number;
			str.append( " = \"" );
			str.append( gtk_entry_get_text( GTK_ENTRY(func_3d[i].entry) ) );
			str.append( "\"" );
			if( settings.show_code )
			{
				(*TEXTVIEW_FUNCTION)( str.c_str() );
				(*TEXTVIEW_FUNCTION)("\n");
			}
			function.set_code_line( str.c_str() );
			function.calc( 0 );
		}


		for( int i=0; i<PLOT_3D_FUNCTIONS; i++ )
		{
			char number[2] = "0";
			if( gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(func_3d[i].check)) == TRUE )
			{
				str = "plot_z_matrix = table2d( z";
				number[0] = '0' + i;
				str.append( number );
				str.append( ", x, dec( " );
				str.append( gtk_entry_get_text( GTK_ENTRY(graphwin_3d_xmin) ) );
				str.append( " ) , dec( " );
				str.append( gtk_entry_get_text( GTK_ENTRY(graphwin_3d_xmax) ) );
				str.append( " ), " );
				str.append( gtk_entry_get_text( GTK_ENTRY(graphwin_3d_xsteps) ) );
				str.append( ", y, dec( " );
				str.append( gtk_entry_get_text( GTK_ENTRY(graphwin_3d_ymin) ) );
				str.append( " ), dec( " );
				str.append( gtk_entry_get_text( GTK_ENTRY(graphwin_3d_ymax) ) );
				str.append( " ), " );
				str.append( gtk_entry_get_text( GTK_ENTRY(graphwin_3d_ysteps) ) );
				str.append( ", i )" );

				if( settings.show_code )
				{
					(*TEXTVIEW_FUNCTION)( str );
					(*TEXTVIEW_FUNCTION)( "\n" );
				}
				function.set_code_line( str.c_str() );
				function.calc( 0 );

				str = "_3d_add_plane( plot_x_matrix, plot_y_matrix, plot_z_matrix, \"";
				switch( gtk_combo_box_get_active( GTK_COMBO_BOX(func_3d[i].combo) ) )
				{
				case 0:  str.append( "Wireframed\", " ); break;
				case 1:  str.append( "Semi-solid\", " ); break;
				default:  str.append( "Solid\", " ); break;
				}
				str.append( gtk_entry_get_text( GTK_ENTRY(graphwin_3d_zmin) ) );
				str.append( ", " );
				str.append( gtk_entry_get_text( GTK_ENTRY(graphwin_3d_zmax) ) );
				str.append( ", [" );

				for( int i2=0; i2<func_3d_colors[i].get_size(); i2++ )
				{
					picture_h::colorrgb *tmp_color;

					str.append( "[ " );

					tmp_color = func_3d_colors[i][i2];
					floatx_to_string( floatx(tmp_color->red)/255.0f, str, format );
					str.append( ", " );
					floatx_to_string( floatx(tmp_color->green)/255.0f, str, format );
					str.append( ", " );
					floatx_to_string( floatx(tmp_color->blue)/255.0f, str, format );

					str.append( " ]" );
				}
				str.append( "] )" );

				if( settings.show_code )
				{
					(*TEXTVIEW_FUNCTION)( str );
					(*TEXTVIEW_FUNCTION)( "\n" );
				}
				function.set_code_line( str.c_str() );
				function.calc( 0 );
			}
		}

		if( settings.show_code )
			(*TEXTVIEW_FUNCTION)( "_3d_render\n" );
		function.set_code_line( "_3d_render\n" );
		function.calc( 0 );
	}
	catch( error_obj error )
	{
		GtkWidget *dialog;

		dialog = gtk_message_dialog_new( GTK_WINDOW(graphwin), GTK_DIALOG_DESTROY_WITH_PARENT,
		                                 GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE, error.msg );
		gtk_dialog_run( GTK_DIALOG(dialog) );
		gtk_widget_destroy(dialog);
	}
	catch( ... )
	{
		try{ THROW_ERROR( ErrorType_Memory, _("Couldn't get memory.") ); }
		catch( error_obj error )
		{
			GtkWidget *dialog;

			dialog = gtk_message_dialog_new( GTK_WINDOW(graphwin), GTK_DIALOG_DESTROY_WITH_PARENT,
			                                 GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE, error.msg );
			gtk_dialog_run( GTK_DIALOG(dialog) );
			gtk_widget_destroy(dialog);
		}
	}
}

GtkWidget *graphwin_3d_tab_functions(void)
{
#define NUM_GRADIENTS 3
	static char gradients[NUM_GRADIENTS][30] =
		{
			"ff0000 0000ff ff00ff",
			"ff00e0 ff0000 ffff00",
			"0000ff 009090 000000 0000ff"
		};
	
	GtkWidget *table, *tmp;
	char tmp_str[100];
	bool tmp_bool;
	const char *tmp_char_ptr;
	const utf8_string *str;

	table = gtk_table_new( PLOT_3D_FUNCTIONS*2, 4, FALSE );

	gtk_container_set_border_width( GTK_CONTAINER(table), 3 );

	for( int i=0; i<PLOT_3D_FUNCTIONS; i++ )
	{
		func_3d[i].entry2 = 0;
		func_3d[i].entry = gtk_entry_new();
		
		snprintf( tmp_str, 100, "GRAPHTOOL_3D_Z%ld_ENTRY", i );
		gtk_entry_set_text( GTK_ENTRY(func_3d[i].entry),
		                    setup_file.get_key_c_str(tmp_str, "") );
		gtk_table_attach( GTK_TABLE(table), func_3d[i].entry, 1, 3, i*2, i*2+1,
		                  GtkAttachOptions( GTK_EXPAND | GTK_FILL ), GtkAttachOptions(0), 0, 0 );

		g_signal_connect( GTK_OBJECT(func_3d[i].entry), "changed",
						  G_CALLBACK(entry_changed), gpointer(&func_3d[i]) );
		g_signal_connect( GTK_OBJECT(func_3d[i].entry), "insert-text",
						  G_CALLBACK(entry_insert), NULL );
		g_signal_connect_swapped( GTK_OBJECT(func_3d[i].entry), "activate",
								  G_CALLBACK(drawbutton_3d_click), NULL );

		func_3d[i].check = gtk_check_button_new();
		g_signal_connect( GTK_OBJECT(func_3d[i].check), "toggled",
						  G_CALLBACK(checkbox_toggled), gpointer(&func_3d[i]) );
		
		snprintf( tmp_str, 100, "GRAPHTOOL_3D_Z%ld_SHOW", i );
		GET_BOOLEAN_KEY( tmp_str, tmp_bool );
		gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(func_3d[i].check), tmp_bool ? TRUE : FALSE );
		gtk_table_attach( GTK_TABLE(table), func_3d[i].check, 0, 1, i*2, i*2+1, GTK_FILL,
						  GtkAttachOptions(0), 1, 1 );

		snprintf( tmp_str, 100, "z_%ld=", i );
		tmp = gtk_label_new_with_mnemonic( tmp_str );
		gtk_label_set_mnemonic_widget( GTK_LABEL(tmp), func_3d[i].entry );
		gtk_container_add( GTK_CONTAINER(func_3d[i].check), tmp) ;
		
		func_3d[i].combo = gtk_combo_box_new_text();
		gtk_combo_box_append_text( GTK_COMBO_BOX(func_3d[i].combo), "Wireframed" );
		gtk_combo_box_append_text( GTK_COMBO_BOX(func_3d[i].combo), "Semi-solid" );
		gtk_combo_box_append_text( GTK_COMBO_BOX(func_3d[i].combo), "Solid" );
		
		snprintf( tmp_str, 100, "GRAPHTOOL_3D_Z%ld_DRAW_MODE", i );
		tmp_char_ptr = setup_file.get_key_c_str(tmp_str, "Semi-solid");
		if( strcmp( tmp_char_ptr, "Wireframed" ) == 0 )
			gtk_combo_box_set_active( GTK_COMBO_BOX(func_3d[i].combo), 0 );
		else if( strcmp( tmp_char_ptr, "Semi-solid" ) == 0 )
			gtk_combo_box_set_active( GTK_COMBO_BOX(func_3d[i].combo), 1 );
		else // if( strcmp( tmp_char_ptr, "Solid" ) == 0 )
			gtk_combo_box_set_active( GTK_COMBO_BOX(func_3d[i].combo), 2 );
		gtk_table_attach( GTK_TABLE(table), func_3d[i].combo, 1, 2, i*2+1, i*2+2,
		                  GTK_FILL, GtkAttachOptions(0), 1, 1 );

		func_3d[i].button = gtk_button_new();
		g_signal_connect( GTK_OBJECT(func_3d[i].button), "clicked",
		                  G_CALLBACK(gradientbutton_click), GINT_TO_POINTER(i) );

		snprintf( tmp_str, 100, "GRAPHTOOL_3D_Z%ld_COLOR", i );
		tmp_char_ptr = setup_file.get_key_c_str( tmp_str, gradients[i%NUM_GRADIENTS] );
		hexstring_to_colorrgbs( tmp_char_ptr, func_3d_colors[i] );
		tmp = gtk_drawing_area_new();
		func_3d[i].colorpic.set_size( 19, 45 );

		for( int32 i2=0; i2<45; i2++ )
		{
			picture_h::colorrgb tmp_color;
			math::color_list_get_color( func_3d_colors[i], 0.0, 44.0, floatx(44-i2), &tmp_color );
			func_3d[i].colorpic.line( 0, i2, 18, i2, tmp_color );
		}
		func_3d[i].colorpic.connect_to_drawing_area(tmp);
		func_3d[i].colorpic.update();
		gtk_container_add( GTK_CONTAINER(func_3d[i].button), tmp );

		gtk_table_attach( GTK_TABLE(table), func_3d[i].button, 3, 4, i*2, i*2+2,
		                  GtkAttachOptions(0), GtkAttachOptions(0), 1, 1 );
	}

	return table;
}

GtkWidget *graphwin_3d_tab(void)
{
	GtkWidget *vbox, *table;
	const char *tmp_char_ptr;
	int tmp_int;
	
	vbox =  gtk_vbox_new( FALSE, 3 );
	gtk_container_set_border_width( GTK_CONTAINER(vbox), 3 );

	graphwin_3d_frame = gtk_frame_new(0);
	gtk_box_pack_start( GTK_BOX(vbox), graphwin_3d_frame, FALSE, FALSE, 0 );
	
	table = gtk_table_new( 4, 6, FALSE );
	gtk_container_set_border_width( GTK_CONTAINER(table), 3 );
	gtk_container_add( GTK_CONTAINER(graphwin_3d_frame), table );
	
	graphwin_3d_width_label = gtk_label_new(0);
	gtk_table_attach( GTK_TABLE(table), graphwin_3d_width_label, 0, 1, 0, 1, GTK_FILL,
	                  GtkAttachOptions(0), 3, 3 );
	gtk_misc_set_alignment( GTK_MISC(graphwin_3d_width_label), 1, 0.5 );
	graphwin_3d_height_label = gtk_label_new(0);
	gtk_table_attach( GTK_TABLE(table), graphwin_3d_height_label, 0, 1, 1, 2, GTK_FILL,
	                  GtkAttachOptions(0), 3, 3 );
	gtk_misc_set_alignment( GTK_MISC(graphwin_3d_height_label), 1, 0.5 );
	
	if( (tmp_char_ptr = setup_file.get_key_c_str("GRAPHTOOL_3D_WIDTH")) != 0 )
	{
		if(sscanf( tmp_char_ptr, "%ld", &tmp_int ) == 1)
		{
			if( tmp_int < 2  &&  tmp_int > 2000 )
				tmp_int = 400;
		}
		else
			tmp_int = 400;
	}
	else
		tmp_int = 400;
	graphwin_3d_width = gtk_spin_button_new_with_range( 2, 2000, 1 );
	gtk_spin_button_set_value( GTK_SPIN_BUTTON(graphwin_3d_width), tmp_int );
	gtk_table_attach( GTK_TABLE(table), graphwin_3d_width, 1, 2, 0, 1,
	                  GtkAttachOptions(GTK_EXPAND | GTK_FILL), GtkAttachOptions(0), 3, 3 );
	gtk_label_set_mnemonic_widget( GTK_LABEL(graphwin_3d_width_label), graphwin_3d_width );
	if( (tmp_char_ptr = setup_file.get_key_c_str("GRAPHTOOL_3D_HEIGHT")) != 0 )
	{
		if(sscanf( tmp_char_ptr, "%ld", &tmp_int ) == 1)
		{
			if( tmp_int < 2  &&  tmp_int > 2000 )
				tmp_int = 400;
		}
		else
			tmp_int = 400;
	}
	else
		tmp_int = 400;
	graphwin_3d_height = gtk_spin_button_new_with_range( 2, 2000, 1 );
	gtk_spin_button_set_value( GTK_SPIN_BUTTON(graphwin_3d_height), tmp_int );
	gtk_table_attach( GTK_TABLE(table), graphwin_3d_height, 1, 2, 1, 2,
	                  GtkAttachOptions(GTK_EXPAND | GTK_FILL), GtkAttachOptions(0), 3, 3 );
	gtk_label_set_mnemonic_widget( GTK_LABEL(graphwin_3d_height_label), graphwin_3d_height );

	graphwin_3d_xmin_label = gtk_label_new(0);
	gtk_table_attach( GTK_TABLE(table), graphwin_3d_xmin_label, 2, 3, 0, 1, GTK_FILL,
	                  GtkAttachOptions(0), 3, 3 );
	gtk_misc_set_alignment( GTK_MISC(graphwin_3d_xmin_label), 1, 0.5 );
	graphwin_3d_xmax_label = gtk_label_new(0);
	gtk_table_attach( GTK_TABLE(table), graphwin_3d_xmax_label, 2, 3, 1, 2, GTK_FILL,
	                  GtkAttachOptions(0), 3, 3 );
	gtk_misc_set_alignment( GTK_MISC(graphwin_3d_xmax_label), 1, 0.5 );
	graphwin_3d_xsteps_label = gtk_label_new(0);
	gtk_table_attach( GTK_TABLE(table), graphwin_3d_xsteps_label, 2, 3, 2, 3, GTK_FILL,
	                  GtkAttachOptions(0), 3, 3 );
	gtk_misc_set_alignment( GTK_MISC(graphwin_3d_xsteps_label), 1, 0.5 );
	graphwin_3d_ymin_label = gtk_label_new(0);
	gtk_table_attach( GTK_TABLE(table), graphwin_3d_ymin_label, 4, 5, 0, 1, GTK_FILL,
	                  GtkAttachOptions(0), 3, 3 );
	gtk_misc_set_alignment( GTK_MISC(graphwin_3d_ymin_label), 1, 0.5 );
	graphwin_3d_ymax_label = gtk_label_new(0);
	gtk_table_attach( GTK_TABLE(table), graphwin_3d_ymax_label, 4, 5, 1, 2, GTK_FILL,
	                  GtkAttachOptions(0), 3, 3 );
	gtk_misc_set_alignment( GTK_MISC(graphwin_3d_ymax_label), 1, 0.5 );
	graphwin_3d_ysteps_label = gtk_label_new(0);
	gtk_table_attach( GTK_TABLE(table), graphwin_3d_ysteps_label, 4, 5, 2, 3, GTK_FILL,
	                  GtkAttachOptions(0), 3, 3 );
	gtk_misc_set_alignment( GTK_MISC(graphwin_3d_ysteps_label), 1, 0.5 );

	graphwin_3d_xmin = gtk_entry_new();
	gtk_entry_set_text( GTK_ENTRY(graphwin_3d_xmin),
	                    setup_file.get_key_c_str("GRAPHTOOL_3D_XMIN","-10") );
	gtk_table_attach( GTK_TABLE(table), graphwin_3d_xmin, 3, 4, 0, 1,
	                  GtkAttachOptions(GTK_EXPAND | GTK_FILL), GtkAttachOptions(0), 3, 3 );
	graphwin_3d_xmax = gtk_entry_new();
	gtk_entry_set_text( GTK_ENTRY(graphwin_3d_xmax),
	                    setup_file.get_key_c_str("GRAPHTOOL_3D_XMAX","10") );
	gtk_table_attach( GTK_TABLE(table), graphwin_3d_xmax, 3, 4, 1, 2,
	                  GtkAttachOptions(GTK_EXPAND | GTK_FILL), GtkAttachOptions(0), 3, 3 );
	graphwin_3d_xsteps = gtk_spin_button_new_with_range( 1, 10000, 1 );
	gtk_spin_button_set_value( GTK_SPIN_BUTTON(graphwin_3d_xsteps), atoi(setup_file.get_key_c_str("GRAPHTOOL_3D_XSTEPS","50") ) );
	gtk_table_attach( GTK_TABLE(table), graphwin_3d_xsteps, 3, 4, 2, 3,
	                  GtkAttachOptions(GTK_EXPAND | GTK_FILL), GtkAttachOptions(0), 3, 3 );
	graphwin_3d_ymin = gtk_entry_new();
	gtk_entry_set_text( GTK_ENTRY(graphwin_3d_ymin),
	                    setup_file.get_key_c_str("GRAPHTOOL_3D_YMIN","-10") );
	gtk_table_attach( GTK_TABLE(table), graphwin_3d_ymin, 5, 6, 0, 1,
	                  GtkAttachOptions(GTK_EXPAND | GTK_FILL), GtkAttachOptions(0), 3, 3 );
	graphwin_3d_ymax = gtk_entry_new();
	gtk_entry_set_text( GTK_ENTRY(graphwin_3d_ymax),
	                    setup_file.get_key_c_str("GRAPHTOOL_3D_YMAX","10") );
	gtk_table_attach( GTK_TABLE(table), graphwin_3d_ymax, 5, 6, 1, 2,
	                  GtkAttachOptions(GTK_EXPAND | GTK_FILL), GtkAttachOptions(0), 3, 3 );
	graphwin_3d_ysteps = gtk_spin_button_new_with_range( 1, 10000, 1 );
	gtk_spin_button_set_value( GTK_SPIN_BUTTON(graphwin_3d_ysteps), atoi(setup_file.get_key_c_str("GRAPHTOOL_3D_YSTEPS","50") ) );
	gtk_table_attach( GTK_TABLE(table), graphwin_3d_ysteps, 5, 6, 2, 3,
	                  GtkAttachOptions(GTK_EXPAND | GTK_FILL), GtkAttachOptions(0), 3, 3 );

	graphwin_3d_zmin_label = gtk_label_new(0);
	gtk_table_attach( GTK_TABLE(table), graphwin_3d_zmin_label, 2, 3, 3, 4, GTK_FILL,
	                  GtkAttachOptions(0), 3, 3 );
	gtk_misc_set_alignment( GTK_MISC(graphwin_3d_zmin_label), 1, 0.5 );
	graphwin_3d_zmax_label = gtk_label_new(0);
	gtk_table_attach( GTK_TABLE(table), graphwin_3d_zmax_label, 4, 5, 3, 4, GTK_FILL,
	                  GtkAttachOptions(0), 3, 3 );
	gtk_misc_set_alignment( GTK_MISC(graphwin_3d_zmax_label), 1, 0.5 );
	graphwin_3d_zmin = gtk_entry_new();
	gtk_entry_set_text( GTK_ENTRY(graphwin_3d_zmin),
	                    setup_file.get_key_c_str("GRAPHTOOL_3D_ZMIN","-10") );
	gtk_table_attach( GTK_TABLE(table), graphwin_3d_zmin, 3, 4, 3, 4,
	                  GtkAttachOptions(GTK_EXPAND | GTK_FILL), GtkAttachOptions(0), 3, 3 );
	graphwin_3d_zmax = gtk_entry_new();
	gtk_entry_set_text( GTK_ENTRY(graphwin_3d_zmax),
	                    setup_file.get_key_c_str("GRAPHTOOL_3D_ZMAX","10") );
	gtk_table_attach( GTK_TABLE(table), graphwin_3d_zmax, 5, 6, 3, 4,
	                  GtkAttachOptions(GTK_EXPAND | GTK_FILL), GtkAttachOptions(0), 3, 3 );


	gtk_label_set_mnemonic_widget( GTK_LABEL(graphwin_3d_xmin_label), graphwin_3d_xmin );
	gtk_label_set_mnemonic_widget( GTK_LABEL(graphwin_3d_xmax_label), graphwin_3d_xmax );
	gtk_label_set_mnemonic_widget( GTK_LABEL(graphwin_3d_xsteps_label), graphwin_3d_xsteps );
	gtk_label_set_mnemonic_widget( GTK_LABEL(graphwin_3d_ymin_label), graphwin_3d_ymin );
	gtk_label_set_mnemonic_widget( GTK_LABEL(graphwin_3d_ymax_label), graphwin_3d_ymax );
	gtk_label_set_mnemonic_widget( GTK_LABEL(graphwin_3d_ysteps_label), graphwin_3d_ysteps );
	gtk_label_set_mnemonic_widget( GTK_LABEL(graphwin_3d_zmin_label), graphwin_3d_zmin );
	gtk_label_set_mnemonic_widget( GTK_LABEL(graphwin_3d_zmax_label), graphwin_3d_zmax );



	graphwin_3d_notebook = gtk_notebook_new();
	gtk_box_pack_start( GTK_BOX(vbox), graphwin_3d_notebook, TRUE, TRUE, 0 );
	gtk_notebook_append_page( GTK_NOTEBOOK(graphwin_3d_notebook), graphwin_3d_tab_functions(), 0 );

	{
		GtkWidget *box = gtk_hbox_new( FALSE, 0 );
		GtkWidget *tmpimg,*tmpbox,*drawbutton;
		tmpimg = gtk_image_new_from_stock( GTK_STOCK_CLEAR, GTK_ICON_SIZE_BUTTON );
		graphwin_buttonlabel_3d_draw = gtk_label_new( 0 );
		tmpbox = gtk_hbox_new( FALSE, 0 );
		gtk_box_pack_start( GTK_BOX(tmpbox), tmpimg, FALSE, FALSE, 2 );
		gtk_box_pack_start( GTK_BOX(tmpbox), graphwin_buttonlabel_3d_draw, FALSE, FALSE, 2 );
		drawbutton = gtk_button_new();
		gtk_container_add( GTK_CONTAINER(drawbutton), tmpbox );

		g_signal_connect( GTK_OBJECT(drawbutton), "clicked",
						  G_CALLBACK(drawbutton_3d_click), gpointer(0) );
		gtk_box_pack_start( GTK_BOX(box), drawbutton, FALSE, FALSE, 0 );

		gtk_box_pack_start( GTK_BOX(vbox), box, FALSE, FALSE, 0 );
	}

	return vbox;
}
#endif


void graphwin_load_settings(void)
{
	char tmpstr[50];
	const char *tmp;
	const utf8_string *str;

	if((str = setup_file.get_key("GRAPHTOOL_WIDTH")) != 0)
	{
		int32 width;
		if(sscanf( str->c_str(), "%ld", &width ) == 1)
		{
			if( width >= 2  &&  width <= 2000 )
				settings.width = width;
		}
	}
	if((str = setup_file.get_key("GRAPHTOOL_HEIGHT")) != 0)
	{
		int32 height;
		if(sscanf( str->c_str(), "%ld", &height ) == 1)
		{
			if( height >= 2  &&  height <= 2000 )
				settings.height = height;
		}
	}
	if((str = setup_file.get_key("GRAPHTOOL_XMIN")) != 0)
		settings.xmin = *str;
	if((str = setup_file.get_key("GRAPHTOOL_XMAX")) != 0)
		settings.xmax = *str;
	if((str = setup_file.get_key("GRAPHTOOL_YMIN")) != 0)
		settings.ymin = *str;
	if((str = setup_file.get_key("GRAPHTOOL_YMAX")) != 0)
		settings.ymax = *str;

	if((tmp = setup_file.get_key_c_str( "GRAPHTOOL_BGCOLOR" )) != 0)
		hexstring_to_colorrgb( tmp, settings.bgcolor );

	if((tmp = setup_file.get_key_c_str( "GRAPHTOOL_AXES_COLOR" )) != 0)
		hexstring_to_colorrgb( tmp, settings.axes_color );

	if((tmp = setup_file.get_key_c_str( "GRAPHTOOL_GRID_COLOR" )) != 0)
		hexstring_to_colorrgb( tmp, settings.grid_color );

	GET_BOOLEAN_KEY( "GRAPHTOOL_ANTIALIASING", settings.use_antialiasing );
	GET_BOOLEAN_KEY( "GRAPHTOOL_SHOW_CODE", settings.show_code );
	GET_BOOLEAN_KEY( "GRAPHTOOL_AXES_ON", settings.axes_on );
	GET_BOOLEAN_KEY( "GRAPHTOOL_GRID_ON", settings.grid_on );
	if((str = setup_file.get_key("GRAPHTOOL_PLOT_MODE")) != 0)
		settings.plot_mode = *str;
	GET_BOOLEAN_KEY( "GRAPHTOOL_SHOW_ACTIVE_PAGE_ONLY", settings.show_active_page_only );

	if((tmp = setup_file.get_key_c_str("GRAPHTOOL_ACTIVE_PAGE")) != 0)
	{
		int val;
		if(sscanf( tmp, "%ld", &val ) == 1)
		{
			if( val >= 0  &&  val <= 2 )
				settings.active_page = val;
		}
	}

	if((str = setup_file.get_key("GRAPHTOOL_GRID_SCALE1")) != 0)
		settings.grid_scale1 = *str;
	if((str = setup_file.get_key("GRAPHTOOL_GRID_SCALE2")) != 0)
		settings.grid_scale2 = *str;
	if((str = setup_file.get_key("GRAPHTOOL_GRID_TYPE")) != 0)
		settings.grid_type = *str;
	if((str = setup_file.get_key("GRAPHTOOL_AXES_SCALEX")) != 0)
		settings.scalex = *str;
	if((str = setup_file.get_key("GRAPHTOOL_AXES_SCALEY")) != 0)
		settings.scaley = *str;
	if((tmp = setup_file.get_key_c_str("GRAPHTOOL_AXES_SCALE_LENGTH")) != 0)
	{
		int val;
		if(sscanf( tmp, "%ld", &val ) == 1)
		{
			if( val >= 0  &&  val <= 100 )
				settings.scale_length = val;
		}
	}

	if((str = setup_file.get_key("GRAPHTOOL_POLAR_START")) != 0)
		settings.polar_start = *str;
	if((str = setup_file.get_key("GRAPHTOOL_POLAR_STOP")) != 0)
		settings.polar_stop = *str;
	if((str = setup_file.get_key("GRAPHTOOL_POLAR_STEPS")) != 0)
		settings.polar_steps = *str;
	if((str = setup_file.get_key("GRAPHTOOL_PAR_START")) != 0)
		settings.par_start = *str;
	if((str = setup_file.get_key("GRAPHTOOL_PAR_STOP")) != 0)
		settings.par_stop = *str;
	if((str = setup_file.get_key("GRAPHTOOL_PAR_STEPS")) != 0)
		settings.par_steps = *str;

	for(int i=0;i<10;i++)
	{
		snprintf( tmpstr, 50, "GRAPHTOOL_Y%lu_SHOW", i );
		GET_BOOLEAN_KEY( tmpstr, settings.func[i].show_this );

		snprintf( tmpstr, 50, "GRAPHTOOL_Y%lu_ENTRY", i );
		if((str = setup_file.get_key( tmpstr )) != 0)
			settings.func[i].entry = *str;

		snprintf( tmpstr, 50, "GRAPHTOOL_Y%lu_COLOR", i );
		if((tmp = setup_file.get_key_c_str( tmpstr )) != 0)
			hexstring_to_colorrgb( tmp, settings.func[i].color );

		snprintf( tmpstr, 50, "GRAPHTOOL_R%lu_SHOW", i );
		GET_BOOLEAN_KEY( tmpstr, settings.polar[i].show_this );

		snprintf( tmpstr, 50, "GRAPHTOOL_R%lu_ENTRY", i );
		if((str = setup_file.get_key( tmpstr )) != 0)
			settings.polar[i].entry = *str;

		snprintf( tmpstr, 50, "GRAPHTOOL_R%lu_COLOR", i );
		if((tmp = setup_file.get_key_c_str( tmpstr )) != 0)
			hexstring_to_colorrgb( tmp, settings.polar[i].color );

		if(i<5)
		{
			snprintf( tmpstr, 50, "GRAPHTOOL_XF%lu_SHOW", i );
			GET_BOOLEAN_KEY( tmpstr, settings.par[i].show_this );

			snprintf( tmpstr, 50, "GRAPHTOOL_XF%lu_ENTRY", i );
			if((str = setup_file.get_key( tmpstr )) != 0)
				settings.par[i].entry = *str;

			snprintf( tmpstr, 50, "GRAPHTOOL_YF%lu_ENTRY", i );
			if((str = setup_file.get_key( tmpstr )) != 0)
				settings.par[i].entry2 = *str;

			snprintf( tmpstr, 50, "GRAPHTOOL_XF%lu_COLOR", i );
			if((tmp = setup_file.get_key_c_str( tmpstr )) != 0)
				hexstring_to_colorrgb( tmp, settings.par[i].color );
		}
	}
}

GtkWidget* graphwin_build_menu(void)
{
	GtkActionGroup *actions;
	GtkUIManager *ui_manager;
	GError *error = NULL;
	static const gchar *menu =
"<ui>"
"  <menubar>"
"    <menu action='FileMenu'>"
"      <menuitem action='Preferences'/>"
"      <separator/>"
"      <menuitem action='Close'/>"
"      <separator/>"
"      <menuitem action='Quit'/>"
"    </menu>"
"    <menu action='ToolsMenu'>"
"      <menuitem action='Simple'/>"
"      <menuitem action='Advanced'/>"
"      <menuitem action='Editor'/>"
"      <menuitem action='MatrixEdit'/>"
"    </menu>"
"    <menuitem action='About'/>"
"  </menubar>"
"</ui>";
	GtkActionEntry entries[] = {
{ "FileMenu",    NULL,                  menu_file },
{ "Preferences", GTK_STOCK_PREFERENCES, menu_pref,           NULL,      NULL, G_CALLBACK(prefwin_show_graphtool) },
{ "Close",       GTK_STOCK_CLOSE,       menu_file_close,     "<ctrl>W", NULL, G_CALLBACK(graphwin_close) },
{ "Quit",        GTK_STOCK_QUIT,        menu_file_quit,      "<ctrl>Q", NULL, G_CALLBACK(UMP_gtk_quit) },
{ "ToolsMenu",   NULL,                  menu_tools },
{ "Simple",      NULL,                  menu_tools_simple,   NULL,      NULL, G_CALLBACK(simplewin_show) },
{ "Advanced",    NULL,                  menu_tools_advanced, NULL,      NULL, G_CALLBACK(advancedwin_show) },
{ "Editor",      NULL,                  menu_tools_editor,   NULL,      NULL, G_CALLBACK(editor_showwin) },
{ "MatrixEdit",  NULL,                  menu_tools_matrixedit,NULL,     NULL, G_CALLBACK(matrix_editor_show) },
{ "About",       NULL,                  menu_about,          NULL,      NULL, G_CALLBACK(aboutwin_show_graphtool) }
};
	guint n_entries = G_N_ELEMENTS(entries);

	actions = gtk_action_group_new("Actions");
	gtk_action_group_add_actions(actions, entries, n_entries, NULL);
	ui_manager = gtk_ui_manager_new();
	gtk_ui_manager_insert_action_group(ui_manager, actions, 0);
	gtk_window_add_accel_group( GTK_WINDOW(graphwin), gtk_ui_manager_get_accel_group(ui_manager) );
	if (!gtk_ui_manager_add_ui_from_string(ui_manager, menu, -1, &error))
	{
		g_message("building menus failed: %s", error->message);
		g_error_free(error);
		return 0;
	}
	gtk_ui_manager_ensure_update(ui_manager);

	return gtk_ui_manager_get_widget(ui_manager, "/menubar");
}

GtkWindow* graphwin_show(void)
{
	GtkWidget *table,*tmp,*box2,*box3,*drawbutton;
	GtkAdjustment *adj;
	char tmp_str[10];

	if(graphwin == 0)
	{
		graphwin_load_settings();

		graphwin = gtk_window_new(GTK_WINDOW_TOPLEVEL);

		gtk_window_set_title(GTK_WINDOW(graphwin), _("Ump - Graph tools") );
		g_signal_connect_swapped( GTK_OBJECT(graphwin), "delete-event", G_CALLBACK(graphwin_close), NULL );


		graphwin_vbox_top = gtk_vbox_new(FALSE, 0);
		gtk_container_add(GTK_CONTAINER(graphwin),graphwin_vbox_top);

		if((graphwin_menu = graphwin_build_menu()) == 0)
		{
			gtk_widget_destroy( graphwin );
			graphwin = 0;
			return 0;
		}

		gtk_box_pack_start( GTK_BOX(graphwin_vbox_top), graphwin_menu, FALSE, FALSE, 0 );
		
		tmp = gtk_alignment_new( 0.5, 0.5, 1.0, 1.0 );
		gtk_alignment_set_padding( GTK_ALIGNMENT(tmp), 3, 4, 3, 3 );
		gtk_box_pack_start( GTK_BOX(graphwin_vbox_top), tmp, FALSE, FALSE, 0 );

		graphwin_vbox = gtk_vbox_new( FALSE, 3 );
#ifdef PLOT_3D
		notebook_2d_3d = gtk_notebook_new();
		gtk_notebook_append_page( GTK_NOTEBOOK(notebook_2d_3d), graphwin_vbox, gtk_label_new(0) );
		
		gtk_notebook_append_page( GTK_NOTEBOOK(notebook_2d_3d), graphwin_3d_tab(), gtk_label_new(0) );
		
		gtk_container_add( GTK_CONTAINER(tmp), notebook_2d_3d );
#else
		gtk_container_add( GTK_CONTAINER(tmp), graphwin_vbox );
#endif


		graphwin_plot_frame = gtk_frame_new( 0 );
		gtk_box_pack_start( GTK_BOX(graphwin_vbox), graphwin_plot_frame, FALSE, FALSE, 0 );
		gtk_container_set_border_width( GTK_CONTAINER(graphwin_plot_frame), 2 );

		table = gtk_table_new(3, 6, FALSE);
		gtk_table_set_row_spacings( GTK_TABLE(table), 2 );
		gtk_table_set_col_spacings( GTK_TABLE(table), 2 );
		gtk_container_set_border_width( GTK_CONTAINER(table), 2 );
		gtk_container_add( GTK_CONTAINER(graphwin_plot_frame), table );

		graphwin_width = gtk_label_new( 0 );
		gtk_table_attach( GTK_TABLE(table), graphwin_width, 0, 1, 0, 1, GTK_FILL,
		                  GtkAttachOptions(0), 1, 1 );
		gtk_misc_set_alignment(GTK_MISC (graphwin_width), 1, 0.5);

		adj = (GtkAdjustment *) gtk_adjustment_new(settings.width, 2, 2000, 1, 10, 10);
		spinwidth = gtk_spin_button_new(adj, 1, 0);
		gtk_table_attach( GTK_TABLE(table), spinwidth, 1, 2, 0, 1,
		                  GtkAttachOptions(GTK_EXPAND | GTK_FILL), GtkAttachOptions(0), 1, 1 );
		gtk_label_set_mnemonic_widget( GTK_LABEL(graphwin_width), spinwidth );

		graphwin_height = gtk_label_new( 0 );
		gtk_table_attach( GTK_TABLE(table), graphwin_height, 0, 1, 1, 2, GTK_FILL,
		                  GtkAttachOptions(0), 1,  1);
		gtk_misc_set_alignment( GTK_MISC(graphwin_height), 1, 0.5 );

		adj = (GtkAdjustment *) gtk_adjustment_new(settings.height, 2, 2000, 1, 10, 10);
		spinheight = gtk_spin_button_new(adj, 1, 0);
		gtk_table_attach( GTK_TABLE(table), spinheight, 1, 2, 1, 2,
		                  GtkAttachOptions(GTK_EXPAND | GTK_FILL),GtkAttachOptions(0), 1, 1 );
		gtk_label_set_mnemonic_widget( GTK_LABEL(graphwin_height), spinheight );

		graphwin_xmin = gtk_label_new( 0 );
		gtk_table_attach( GTK_TABLE(table), graphwin_xmin, 2, 3, 0, 1, GTK_FILL,
		                  GtkAttachOptions(0), 1, 1);
		gtk_misc_set_alignment(GTK_MISC (graphwin_xmin), 1, 0.5);

		graphwin_xmax = gtk_label_new( 0 );
		gtk_table_attach( GTK_TABLE(table), graphwin_xmax, 2, 3, 1, 2, GTK_FILL,
		                  GtkAttachOptions(0), 1, 1 );
		gtk_misc_set_alignment(GTK_MISC (graphwin_xmax), 1, 0.5);

		entryxmin = gtk_entry_new();
		gtk_table_attach( GTK_TABLE(table), entryxmin, 3, 4, 0, 1, 
		                  GtkAttachOptions(GTK_EXPAND | GTK_FILL), GtkAttachOptions(0), 1, 1 );
		gtk_entry_set_max_length(GTK_ENTRY (entryxmin), 20);
		gtk_entry_set_text(GTK_ENTRY(entryxmin), settings.xmin.c_str() );
		gtk_label_set_mnemonic_widget( GTK_LABEL(graphwin_xmin), entryxmin );

		entryxmax = gtk_entry_new();
		gtk_table_attach( GTK_TABLE(table), entryxmax, 3, 4, 1, 2,
		                  GtkAttachOptions(GTK_EXPAND | GTK_FILL), GtkAttachOptions(0), 1, 1 );
		gtk_entry_set_max_length(GTK_ENTRY(entryxmax), 20);
		gtk_entry_set_text(GTK_ENTRY(entryxmax), settings.xmax.c_str() );
		gtk_label_set_mnemonic_widget( GTK_LABEL(graphwin_xmax), entryxmax );

		graphwin_ymin = gtk_label_new( 0 );
		gtk_table_attach( GTK_TABLE(table), graphwin_ymin, 4, 5, 0, 1, GTK_FILL,
		                  GtkAttachOptions(0), 1, 1 );
		gtk_misc_set_alignment(GTK_MISC (graphwin_ymin), 1, 0.5);

		graphwin_ymax = gtk_label_new( 0 );
		gtk_table_attach( GTK_TABLE(table), graphwin_ymax, 4, 5, 1, 2, GTK_FILL,
		                  GtkAttachOptions(0), 1, 1 );
		gtk_misc_set_alignment(GTK_MISC (graphwin_ymax), 1, 0.5);

		entryymin = gtk_entry_new();
		gtk_table_attach( GTK_TABLE(table), entryymin, 5, 6, 0, 1,
		                  GtkAttachOptions(GTK_EXPAND | GTK_FILL), GtkAttachOptions(0), 1, 1 );
		gtk_entry_set_max_length(GTK_ENTRY (entryymin), 20);
		gtk_entry_set_text(GTK_ENTRY(entryymin), settings.ymin.c_str() );
		gtk_label_set_mnemonic_widget( GTK_LABEL(graphwin_ymin), entryymin );

		entryymax = gtk_entry_new();
		gtk_table_attach( GTK_TABLE(table), entryymax, 5, 6, 1, 2,
		                  GtkAttachOptions(GTK_EXPAND | GTK_FILL), GtkAttachOptions(0), 1, 1 );
		gtk_entry_set_max_length(GTK_ENTRY(entryymax), 20);
		gtk_entry_set_text(GTK_ENTRY(entryymax), settings.ymax.c_str() );
		gtk_label_set_mnemonic_widget( GTK_LABEL(graphwin_ymax), entryymax );

		checkaxes = gtk_check_button_new_with_mnemonic( 0 );
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkaxes), settings.axes_on ? TRUE : FALSE );
		gtk_table_attach( GTK_TABLE(table), checkaxes, 0, 2, 2, 3, GTK_FILL,
		                  GtkAttachOptions(0), 1, 1 );

		checkgrid = gtk_check_button_new_with_mnemonic( 0 );
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkgrid), settings.grid_on ? TRUE : FALSE );
		gtk_table_attach( GTK_TABLE(table), checkgrid, 2, 4, 2, 3, GTK_FILL,
		                  GtkAttachOptions(0), 1, 1 );

		{
			GtkWidget *tmpimg,*tmpbox;
			tmpimg = gtk_image_new_from_stock( GTK_STOCK_PREFERENCES, GTK_ICON_SIZE_BUTTON );
			graphwin_buttonlabel_settings = gtk_label_new( 0 );
			tmpbox = gtk_hbox_new(FALSE,0);
			gtk_box_pack_start( GTK_BOX(tmpbox), tmpimg, FALSE, FALSE, 2 );
			gtk_box_pack_start( GTK_BOX(tmpbox), graphwin_buttonlabel_settings, FALSE, FALSE, 2 );
			tmp = gtk_button_new();
			gtk_container_add(GTK_CONTAINER(tmp),tmpbox);
		}
		g_signal_connect( GTK_OBJECT(tmp), "clicked", G_CALLBACK(graphwin_settings_show), NULL );
		gtk_table_attach( GTK_TABLE(table), tmp, 5, 6, 2, 3, GTK_FILL, GtkAttachOptions(0), 1, 1 );


		notebook = gtk_notebook_new();

// Page 'Functions' starts
		table = gtk_table_new(10, 3, FALSE);
		gtk_container_set_border_width( GTK_CONTAINER(table), 2 );

		for(int i=0;i<10;i++)
		{
			func[i].entry2 = 0;
			func[i].entry = gtk_entry_new();
			gtk_table_attach( GTK_TABLE(table), func[i].entry, 1, 2, i, i+1,
			                  GtkAttachOptions(GTK_EXPAND | GTK_FILL),
			                  GtkAttachOptions(0), 1, 1 );
			gtk_entry_set_max_length( GTK_ENTRY(func[i].entry), max_len_entry );
			gtk_entry_set_text( GTK_ENTRY(func[i].entry), settings.func[i].entry.c_str() );
			g_signal_connect( GTK_OBJECT(func[i].entry), "changed",
			                  G_CALLBACK(entry_changed), gpointer(&func[i]) );
			g_signal_connect( GTK_OBJECT(func[i].entry), "insert-text",
			                  G_CALLBACK(entry_insert), NULL );
			g_signal_connect_swapped( GTK_OBJECT(func[i].entry), "activate",
			                          G_CALLBACK(drawbutton_click), NULL );
			
			func[i].check = gtk_check_button_new();
			g_signal_connect( GTK_OBJECT(func[i].check), "toggled",
			                  G_CALLBACK(checkbox_toggled), gpointer(&func[i]) );
			gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(func[i].check), settings.func[i].show_this ? TRUE : FALSE );
			gtk_table_attach( GTK_TABLE(table), func[i].check, 0, 1, i, i+1, GTK_FILL,
			                  GtkAttachOptions(0), 1, 1 );
			
			snprintf( tmp_str, 10, "y_%ld=", i );
			tmp = gtk_label_new_with_mnemonic( tmp_str );
			gtk_label_set_mnemonic_widget(GTK_LABEL(tmp),func[i].entry);
			gtk_container_add(GTK_CONTAINER(func[i].check),tmp);
			
			
			func[i].button = gtk_button_new();
			g_signal_connect( GTK_OBJECT(func[i].button), "clicked",
			                  G_CALLBACK(colorbutton_click), gpointer(&func[i].colorpic) );
			
			tmp = gtk_drawing_area_new();
			func[i].colorpic.set_size( 19, 19 );
			func[i].colorpic.clear( settings.func[i].color );
			func[i].colorpic.connect_to_drawing_area(tmp);
			func[i].colorpic.update();
			gtk_container_add( GTK_CONTAINER(func[i].button), tmp );
			
			gtk_table_attach( GTK_TABLE(table), func[i].button, 2, 3, i, i+1,
			                  GtkAttachOptions(0), GtkAttachOptions(0), 1, 1 );
		}
		gtk_notebook_append_page( GTK_NOTEBOOK(notebook), table, 0 );
// Page 'Functions' ends

// Page 'Polar functions' starts
		box2 = gtk_vbox_new(FALSE,0);
		gtk_container_set_border_width( GTK_CONTAINER(box2), 2 );

		box3 = gtk_hbox_new(FALSE,0);
		graphwin_polar_start = gtk_label_new( 0 );
		gtk_misc_set_alignment(GTK_MISC(graphwin_polar_start), 1, 0.5);
		gtk_box_pack_start(GTK_BOX(box3),graphwin_polar_start,FALSE,FALSE,0);

		polarentrystart = gtk_entry_new();
		g_signal_connect_swapped( GTK_OBJECT(polarentrystart), "activate",
		                          G_CALLBACK(drawbutton_click), NULL );
		gtk_entry_set_max_length( GTK_ENTRY(polarentrystart), 20 );
		gtk_entry_set_text( GTK_ENTRY(polarentrystart), settings.polar_start.c_str() );
		gtk_box_pack_start( GTK_BOX(box3), polarentrystart, FALSE, FALSE, 0 );
		gtk_label_set_mnemonic_widget( GTK_LABEL(graphwin_polar_start), polarentrystart );

		graphwin_polar_stop = gtk_label_new( 0 );
		gtk_misc_set_alignment(GTK_MISC(graphwin_polar_stop), 1, 0.5);
		gtk_box_pack_start(GTK_BOX(box3),graphwin_polar_stop,FALSE,FALSE,0);

		polarentrystop = gtk_entry_new();
		g_signal_connect_swapped( GTK_OBJECT(polarentrystop), "activate",
		                          G_CALLBACK(drawbutton_click), NULL );
		gtk_entry_set_max_length( GTK_ENTRY(polarentrystop), 20 );
		gtk_entry_set_text( GTK_ENTRY(polarentrystop), settings.polar_stop.c_str() );
		gtk_box_pack_start( GTK_BOX(box3), polarentrystop, FALSE, FALSE, 0 );
		gtk_label_set_mnemonic_widget( GTK_LABEL(graphwin_polar_stop), polarentrystop );

		graphwin_polar_steps = gtk_label_new_with_mnemonic( _(" St_eps:") );
		gtk_misc_set_alignment(GTK_MISC(graphwin_polar_steps), 1, 0.5);
		gtk_box_pack_start(GTK_BOX(box3),graphwin_polar_steps,FALSE,FALSE,0);

		polarentrystep = gtk_spin_button_new_with_range( 1, 10000, 1 );
		g_signal_connect_swapped( GTK_OBJECT(polarentrystep), "activate",
		                          G_CALLBACK(drawbutton_click), NULL );
		gtk_spin_button_set_value( GTK_SPIN_BUTTON(polarentrystep), atoi(settings.polar_steps.c_str()) );
		gtk_box_pack_start( GTK_BOX(box3), polarentrystep, TRUE, TRUE, 0 );
		gtk_label_set_mnemonic_widget( GTK_LABEL(graphwin_polar_steps),polarentrystep );

		gtk_box_pack_start( GTK_BOX(box2), box3, FALSE, FALSE, 2 );

		table = gtk_table_new(10, 3, FALSE);
		gtk_box_pack_start(GTK_BOX(box2),table,FALSE,FALSE,0);

		for(int i=0;i<10;i++)
		{
			polar[i].entry2 = 0;
			polar[i].entry = gtk_entry_new();
			gtk_table_attach( GTK_TABLE(table), polar[i].entry, 1, 2, i, i+1,
			                  GtkAttachOptions(GTK_EXPAND | GTK_FILL),
			                  GtkAttachOptions(0), 1, 1);
			gtk_entry_set_max_length( GTK_ENTRY(polar[i].entry), max_len_entry );
			gtk_entry_set_text( GTK_ENTRY(polar[i].entry), settings.polar[i].entry.c_str() );
			g_signal_connect( GTK_OBJECT(polar[i].entry), "changed",
			                  G_CALLBACK(entry_changed), gpointer(&polar[i]) );
			g_signal_connect( GTK_OBJECT(polar[i].entry), "insert-text",
			                  G_CALLBACK(entry_insert), NULL );
			g_signal_connect_swapped( GTK_OBJECT(polar[i].entry), "activate",
			                          G_CALLBACK(drawbutton_click), NULL );

			polar[i].check = gtk_check_button_new();
			g_signal_connect( GTK_OBJECT(polar[i].check), "toggled",
			                  G_CALLBACK(checkbox_toggled), gpointer(&polar[i]) );
			gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(polar[i].check),
			                              settings.polar[i].show_this ? TRUE : FALSE );
			gtk_table_attach( GTK_TABLE(table), polar[i].check, 0, 1, i, i+1, GTK_FILL,
			                  GtkAttachOptions(0), 1, 1);

			snprintf( tmp_str, 10, "r_%ld=", i );
			tmp = gtk_label_new_with_mnemonic( tmp_str );
			gtk_label_set_mnemonic_widget(GTK_LABEL(tmp),polar[i].entry);
			gtk_container_add(GTK_CONTAINER(polar[i].check),tmp);


			polar[i].button = gtk_button_new();
			g_signal_connect( GTK_OBJECT(polar[i].button), "clicked",
			                  G_CALLBACK(colorbutton_click), gpointer(&polar[i].colorpic) );

			tmp = gtk_drawing_area_new();
			polar[i].colorpic.set_size( 19, 19 );
			polar[i].colorpic.clear( settings.polar[i].color );
			polar[i].colorpic.connect_to_drawing_area(tmp);
			polar[i].colorpic.update();
			gtk_container_add(GTK_CONTAINER(polar[i].button),tmp);

			gtk_table_attach( GTK_TABLE(table), polar[i].button, 2, 3, i, i+1,
			                  GtkAttachOptions(0), GtkAttachOptions(0), 1, 1 );
		}

		gtk_notebook_append_page( GTK_NOTEBOOK(notebook), box2, 0 );
// Page 'Polar functions' ends

// Page 'Parametric functions' starts
		box2 = gtk_vbox_new(FALSE,0);
		gtk_container_set_border_width( GTK_CONTAINER(box2), 2 );

		box3 = gtk_hbox_new(FALSE,0);
		graphwin_para_start = gtk_label_new( 0 );
		gtk_misc_set_alignment(GTK_MISC(graphwin_para_start), 1, 0.5);
		gtk_box_pack_start(GTK_BOX(box3),graphwin_para_start,FALSE,FALSE,0);

		parentrystart = gtk_entry_new();
		g_signal_connect_swapped( GTK_OBJECT(parentrystart), "activate",
		                          G_CALLBACK(drawbutton_click), NULL );
		gtk_entry_set_max_length( GTK_ENTRY(parentrystart), 20);
		gtk_entry_set_text( GTK_ENTRY(parentrystart), settings.par_start.c_str() );
		gtk_box_pack_start( GTK_BOX(box3), parentrystart, FALSE, FALSE, 0 );
		gtk_label_set_mnemonic_widget( GTK_LABEL(graphwin_para_start), parentrystart );

		graphwin_para_stop = gtk_label_new( 0 );
		gtk_misc_set_alignment(GTK_MISC(graphwin_para_stop), 1, 0.5);
		gtk_box_pack_start(GTK_BOX(box3),graphwin_para_stop,FALSE,FALSE,0);

		parentrystop = gtk_entry_new();
		g_signal_connect_swapped( GTK_OBJECT(parentrystop), "activate",
		                          G_CALLBACK(drawbutton_click), NULL );
		gtk_entry_set_max_length( GTK_ENTRY(parentrystop), 20 );
		gtk_entry_set_text( GTK_ENTRY(parentrystop), settings.par_stop.c_str() );
		gtk_box_pack_start( GTK_BOX(box3), parentrystop, FALSE, FALSE, 0 );
		gtk_label_set_mnemonic_widget( GTK_LABEL(graphwin_para_stop), parentrystop );

		graphwin_para_steps = gtk_label_new( 0 );
		gtk_misc_set_alignment( GTK_MISC(graphwin_para_steps), 1, 0.5 );
		gtk_box_pack_start( GTK_BOX(box3), graphwin_para_steps, FALSE, FALSE, 0 );

		parentrystep = gtk_spin_button_new_with_range( 1, 10000, 1 );
		g_signal_connect_swapped( GTK_OBJECT(parentrystep), "activate",
		                          G_CALLBACK(drawbutton_click), NULL );
		gtk_entry_set_max_length( GTK_ENTRY(parentrystep), 20);
		gtk_spin_button_set_value( GTK_SPIN_BUTTON(parentrystep), atoi(settings.par_steps.c_str()) );
		gtk_box_pack_start( GTK_BOX(box3), parentrystep, TRUE, TRUE, 0 );
		gtk_label_set_mnemonic_widget( GTK_LABEL(graphwin_para_steps), parentrystep );

		gtk_box_pack_start( GTK_BOX(box2), box3, FALSE, FALSE, 2 );

		table = gtk_table_new( 10, 3, FALSE );
		gtk_box_pack_start( GTK_BOX(box2), table, FALSE, FALSE, 0 );

		for(int i=0;i<5;i++)
		{
			par[i].entry = gtk_entry_new();
			gtk_table_attach( GTK_TABLE(table), par[i].entry, 1, 2, i*2, i*2+1,
			                  GtkAttachOptions(GTK_EXPAND | GTK_FILL),
			                  GtkAttachOptions(0), 1, 1 );
			gtk_entry_set_max_length(GTK_ENTRY(par[i].entry), max_len_entry);
			gtk_entry_set_text(GTK_ENTRY(par[i].entry), settings.par[i].entry.c_str() );
			g_signal_connect( GTK_OBJECT(par[i].entry), "changed",
			                  G_CALLBACK(entry_changed), gpointer(&par[i]) );
			g_signal_connect( GTK_OBJECT(par[i].entry), "insert-text",
			                  G_CALLBACK(entry_insert), NULL );
			g_signal_connect_swapped( GTK_OBJECT(par[i].entry), "activate",
			                          G_CALLBACK(drawbutton_click), NULL );

			par[i].entry2 = gtk_entry_new();
			gtk_table_attach( GTK_TABLE(table), par[i].entry2, 1, 2, i*2+1, i*2+2,
			                  GtkAttachOptions(GTK_EXPAND | GTK_FILL),
			                  GtkAttachOptions(0), 1, 1 );
			gtk_entry_set_max_length(GTK_ENTRY(par[i].entry2), max_len_entry);
			gtk_entry_set_text(GTK_ENTRY(par[i].entry2), settings.par[i].entry2.c_str() );
			g_signal_connect( GTK_OBJECT(par[i].entry2), "changed",
			                  G_CALLBACK(entry_changed), gpointer(&par[i]) );
			g_signal_connect( GTK_OBJECT(par[i].entry2), "insert-text",
			                  G_CALLBACK(entry_insert), NULL );
			g_signal_connect_swapped( GTK_OBJECT(par[i].entry2), "activate",
			                          G_CALLBACK(drawbutton_click), NULL );

			par[i].check = gtk_check_button_new();
			g_signal_connect( GTK_OBJECT(par[i].check), "toggled",
			                  G_CALLBACK(checkbox_toggled), gpointer(&par[i]) );
			gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(par[i].check),
			                              settings.par[i].show_this ? TRUE : FALSE );
			gtk_table_attach( GTK_TABLE(table), par[i].check, 0, 1, i*2, i*2+1, GTK_FILL,
			                  GtkAttachOptions(0), 1, 1 );

			snprintf( tmp_str, 10, "yf_%ld=", i );
			tmp = gtk_label_new_with_mnemonic( tmp_str );
			gtk_table_attach( GTK_TABLE(table), tmp, 0, 1, i*2+1, i*2+2, GTK_FILL,
			                  GtkAttachOptions(0), 1, 1 );
			gtk_label_set_mnemonic_widget( GTK_LABEL(tmp), par[i].entry2 );
			gtk_misc_set_alignment( GTK_MISC(tmp), 1.0f, 0.5f );

			snprintf( tmp_str, 10, "xf_%ld=", i );
			tmp = gtk_label_new_with_mnemonic( tmp_str );
			gtk_label_set_mnemonic_widget(GTK_LABEL(tmp),par[i].entry);
			gtk_container_add(GTK_CONTAINER(par[i].check),tmp);


			par[i].button = gtk_button_new();
			g_signal_connect( GTK_OBJECT(par[i].button), "clicked",
			                  G_CALLBACK(colorbutton_click), gpointer(&par[i].colorpic) );

			tmp = gtk_drawing_area_new();
			par[i].colorpic.set_size( 19, 45 );
			par[i].colorpic.clear( settings.par[i].color );
			par[i].colorpic.connect_to_drawing_area(tmp);
			par[i].colorpic.update();
			gtk_container_add( GTK_CONTAINER(par[i].button), tmp );

			gtk_table_attach( GTK_TABLE(table), par[i].button, 2, 3, i*2, i*2+2,
			                  GtkAttachOptions(0), GtkAttachOptions(0), 1, 1 );
		}

		gtk_notebook_append_page( GTK_NOTEBOOK(notebook), box2, 0 );
// Page 'Parametric functions' ends


		gtk_box_pack_start( GTK_BOX(graphwin_vbox), notebook, TRUE, TRUE, 0 );
		gtk_container_set_border_width( GTK_CONTAINER(notebook), 2 );


		box2 = gtk_hbox_new( FALSE, 0 );
		{
			GtkWidget *tmpimg,*tmpbox;
			tmpimg = gtk_image_new_from_stock( GTK_STOCK_CLEAR, GTK_ICON_SIZE_BUTTON );
			graphwin_buttonlabel_draw = gtk_label_new( 0 );
			tmpbox = gtk_hbox_new(FALSE,0);
			gtk_box_pack_start( GTK_BOX(tmpbox), tmpimg, FALSE, FALSE, 2 );
			gtk_box_pack_start( GTK_BOX(tmpbox), graphwin_buttonlabel_draw, FALSE, FALSE, 2 );
			drawbutton = gtk_button_new();
			gtk_container_add( GTK_CONTAINER(drawbutton), tmpbox );
		}
		g_signal_connect( GTK_OBJECT(drawbutton), "clicked",
		                  G_CALLBACK(drawbutton_click), gpointer(0) );
		gtk_box_pack_start( GTK_BOX(box2), drawbutton, FALSE, FALSE, 2 );

		gtk_box_pack_start( GTK_BOX(graphwin_vbox), box2, FALSE, FALSE, 3 );

		graphwin_translate(); // fix all strings

		gtk_widget_show_all(graphwin);
		open_windows |= GRAPHTOOL_WIN;

		switch(settings.active_page)
		{
		case 1: // polar
			gtk_notebook_set_current_page( GTK_NOTEBOOK(notebook), 1 );
			gtk_widget_grab_focus(polar[0].entry);
			break;
		case 2: // parametric
			gtk_notebook_set_current_page( GTK_NOTEBOOK(notebook), 2 );
			gtk_widget_grab_focus(par[0].entry);
			break;
		default: // function
			gtk_notebook_set_current_page( GTK_NOTEBOOK(notebook), 0 );
			gtk_widget_grab_focus(func[0].entry);
		}
#ifdef PLOT_3D
		{
			bool tmp_bool = false;
			const utf8_string *str;
			GET_BOOLEAN_KEY( "GRAPHTOOL_3D_ACTIVE", tmp_bool );
			gtk_notebook_set_current_page( GTK_NOTEBOOK(notebook_2d_3d), tmp_bool ? 1 : 0 );
		}
#endif
	}
	else
		gtk_window_present(GTK_WINDOW(graphwin));

	return GTK_WINDOW( graphwin );
}

void graphwin_translate(void)
{
	if(graphwin != 0)
	{
		GtkWidget *new_menu;
		GtkWidget *label;

		gtk_window_set_title(GTK_WINDOW(graphwin), _("Ump - Graph tools") );


		gtk_frame_set_label( GTK_FRAME(graphwin_plot_frame), _("Plot window") );

		gtk_label_set_text_with_mnemonic( GTK_LABEL(graphwin_width), _("_Width:") );
		gtk_label_set_text_with_mnemonic( GTK_LABEL(graphwin_height), _("_Height:") );

		gtk_label_set_text_with_mnemonic( GTK_LABEL(graphwin_xmin), _("  Xmin:") );
		gtk_label_set_text_with_mnemonic( GTK_LABEL(graphwin_xmax), _("  Xmax:") );
		gtk_label_set_text_with_mnemonic( GTK_LABEL(graphwin_ymin), _("  Ymin:") );
		gtk_label_set_text_with_mnemonic( GTK_LABEL(graphwin_ymax), _("  Ymax:") );

		gtk_button_set_label( GTK_BUTTON(checkaxes), _("Show a_xes") );
		gtk_button_set_label( GTK_BUTTON(checkgrid), _("Show _grid") );


		gtk_label_set_text_with_mnemonic( GTK_LABEL(graphwin_buttonlabel_settings),
		                                  _("More _settings") );
		{
			const char *trans;
			trans = _(" _Start:");
			gtk_label_set_text_with_mnemonic( GTK_LABEL(graphwin_polar_start), trans );
			gtk_label_set_text_with_mnemonic( GTK_LABEL(graphwin_para_start), trans );

			trans = _(" S_top:");
			gtk_label_set_text_with_mnemonic( GTK_LABEL(graphwin_polar_stop), trans );
			gtk_label_set_text_with_mnemonic( GTK_LABEL(graphwin_para_stop), trans );

			trans = _(" St_eps:");
			gtk_label_set_text_with_mnemonic( GTK_LABEL(graphwin_polar_steps), trans );
			gtk_label_set_text_with_mnemonic( GTK_LABEL(graphwin_para_steps), trans );
		}

		gtk_label_set_text_with_mnemonic( GTK_LABEL(graphwin_buttonlabel_draw), _("Draw") );

		label = gtk_label_new_with_mnemonic( _("_Functions") );
		gtk_notebook_set_tab_label( GTK_NOTEBOOK(notebook),
		                   gtk_notebook_get_nth_page( GTK_NOTEBOOK(notebook), 0), label );

		label = gtk_label_new_with_mnemonic( _("_Polar functions") );
		gtk_notebook_set_tab_label( GTK_NOTEBOOK(notebook),
		                   gtk_notebook_get_nth_page( GTK_NOTEBOOK(notebook), 1), label );

		label = gtk_label_new_with_mnemonic( _("Pa_rametric functions") );
		gtk_notebook_set_tab_label( GTK_NOTEBOOK(notebook),
		                   gtk_notebook_get_nth_page( GTK_NOTEBOOK(notebook), 2), label );
		
#ifdef PLOT_3D
		label = gtk_label_new_with_mnemonic( _("_2D plot") );
		gtk_notebook_set_tab_label( GTK_NOTEBOOK(notebook_2d_3d),
		                   gtk_notebook_get_nth_page( GTK_NOTEBOOK(notebook_2d_3d), 0), label );

		label = gtk_label_new_with_mnemonic( _("_3D plot") );
		gtk_notebook_set_tab_label( GTK_NOTEBOOK(notebook_2d_3d),
		                   gtk_notebook_get_nth_page( GTK_NOTEBOOK(notebook_2d_3d), 1), label );
		
		gtk_frame_set_label( GTK_FRAME(graphwin_3d_frame), _("Plot window") );
		
		gtk_label_set_text_with_mnemonic( GTK_LABEL(graphwin_3d_width_label), _("_Width:") );
		gtk_label_set_text_with_mnemonic( GTK_LABEL(graphwin_3d_height_label), _("_Height:") );
		gtk_label_set_text_with_mnemonic( GTK_LABEL(graphwin_3d_xmin_label), _("  Xmin:") );
		gtk_label_set_text_with_mnemonic( GTK_LABEL(graphwin_3d_xmax_label), _("  Xmax:") );
		gtk_label_set_text_with_mnemonic( GTK_LABEL(graphwin_3d_xsteps_label), _("  Xsteps:") );
		gtk_label_set_text_with_mnemonic( GTK_LABEL(graphwin_3d_ymin_label), _("  Ymin:") );
		gtk_label_set_text_with_mnemonic( GTK_LABEL(graphwin_3d_ymax_label), _("  Ymax:") );
		gtk_label_set_text_with_mnemonic( GTK_LABEL(graphwin_3d_ysteps_label), _("  Ysteps:") );
		gtk_label_set_text_with_mnemonic( GTK_LABEL(graphwin_3d_zmin_label), _("  Zmin:") );
		gtk_label_set_text_with_mnemonic( GTK_LABEL(graphwin_3d_zmax_label), _("  Zmax:") );
		
		label = gtk_label_new_with_mnemonic( _("_Functions") );
		gtk_notebook_set_tab_label( GTK_NOTEBOOK(graphwin_3d_notebook),
		                gtk_notebook_get_nth_page( GTK_NOTEBOOK(graphwin_3d_notebook), 0), label );

		gtk_label_set_text_with_mnemonic( GTK_LABEL(graphwin_buttonlabel_3d_draw), _("Draw") );
		
		for( int i=0; i<PLOT_3D_FUNCTIONS; i++ )
		{
			gtk_combo_box_append_text( GTK_COMBO_BOX(func_3d[i].combo), _("Wireframed") );
			gtk_combo_box_append_text( GTK_COMBO_BOX(func_3d[i].combo), _("Semi-solid") );
			gtk_combo_box_append_text( GTK_COMBO_BOX(func_3d[i].combo), _("Solid") );
			
			gtk_combo_box_set_active( GTK_COMBO_BOX(func_3d[i].combo), 
			               gtk_combo_box_get_active( GTK_COMBO_BOX(func_3d[i].combo) )+3 );
		}

		for( int i=0; i<PLOT_3D_FUNCTIONS; i++ )
		{
			for( int i2=0; i2<3; i2++ )
				gtk_combo_box_remove_text( GTK_COMBO_BOX(func_3d[i].combo), 0 );
		}
#endif

		if( (new_menu = graphwin_build_menu()) == 0 )
			return;

		gtk_widget_destroy( graphwin_menu );
		graphwin_menu = new_menu;

		gtk_box_pack_start(GTK_BOX(graphwin_vbox_top), graphwin_menu, FALSE, FALSE, 0);
		gtk_box_reorder_child( GTK_BOX(graphwin_vbox_top), graphwin_menu, 0 );
	}
}

void graphwin_close(void)
{
	if(graphwin != 0)
	{
		char str[50], str2[10];

#ifdef PLOT_3D
		settings.active_page = gtk_notebook_get_current_page(GTK_NOTEBOOK(notebook));
		setup_file.set_key( "GRAPHTOOL_3D_ACTIVE", 
		   (gtk_notebook_get_current_page(GTK_NOTEBOOK(notebook_2d_3d)) == 1) ? "True" : "False" );
		
		setup_file.set_key( "GRAPHTOOL_3D_WIDTH", gtk_entry_get_text( GTK_ENTRY(graphwin_3d_width) ) );
		setup_file.set_key( "GRAPHTOOL_3D_HEIGHT", gtk_entry_get_text( GTK_ENTRY(graphwin_3d_height) ) );

		setup_file.set_key( "GRAPHTOOL_3D_XMIN", gtk_entry_get_text( GTK_ENTRY(graphwin_3d_xmin) ) );
		setup_file.set_key( "GRAPHTOOL_3D_XMAX", gtk_entry_get_text( GTK_ENTRY(graphwin_3d_xmax) ) );
		setup_file.set_key( "GRAPHTOOL_3D_XSTEPS", gtk_entry_get_text( GTK_ENTRY(graphwin_3d_xsteps) ) );
		setup_file.set_key( "GRAPHTOOL_3D_YMIN", gtk_entry_get_text( GTK_ENTRY(graphwin_3d_ymin) ) );
		setup_file.set_key( "GRAPHTOOL_3D_YMAX", gtk_entry_get_text( GTK_ENTRY(graphwin_3d_ymax) ) );
		setup_file.set_key( "GRAPHTOOL_3D_YSTEPS", gtk_entry_get_text( GTK_ENTRY(graphwin_3d_ysteps) ) );
		setup_file.set_key( "GRAPHTOOL_3D_ZMIN", gtk_entry_get_text( GTK_ENTRY(graphwin_3d_zmin) ) );
		setup_file.set_key( "GRAPHTOOL_3D_ZMAX", gtk_entry_get_text( GTK_ENTRY(graphwin_3d_zmax) ) );
		
		{
			bool tmp_bool;
			const char *tmp_char_ptr;
			utf8_string color_str;

			for(int i=0;i<PLOT_3D_FUNCTIONS;i++)
			{
				tmp_bool =  (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(func_3d[i].check)) == TRUE) ? true : false;
				snprintf( str, 50, "GRAPHTOOL_3D_Z%lu_SHOW", i );
				setup_file.set_key( str, tmp_bool ? "True" : "False" );

				tmp_char_ptr = gtk_entry_get_text(GTK_ENTRY(func_3d[i].entry));
				snprintf( str, 50, "GRAPHTOOL_3D_Z%lu_ENTRY", i );
				setup_file.set_key( str, tmp_char_ptr );

				snprintf( str, 50, "GRAPHTOOL_3D_Z%ld_DRAW_MODE", i );
				switch( gtk_combo_box_get_active( GTK_COMBO_BOX(func_3d[i].combo) ) )
				{
				case 0:
					setup_file.set_key( str, "Wireframed" );
					break;
				case 1:
					setup_file.set_key( str, "Semi-solid" );
					break;
				default:
					setup_file.set_key( str, "Solid" );
					break;
				}

				color_str = "";
				for( int i2=0; i2<func_3d_colors[i].get_size(); i2++ )
				{
					snprintf( str, 50, "%02lx%02lx%02lx", func_3d_colors[i][i2]->red,
					          func_3d_colors[i][i2]->green, func_3d_colors[i][i2]->blue );
					if( i2 != 0 )
						color_str.append( " " );
					color_str.append( str );
				}
				snprintf( str, 50, "GRAPHTOOL_3D_Z%ld_COLOR", i );
				setup_file.set_key( str, color_str );
			}
		}
#endif
		
		settings.width = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(spinwidth));
		snprintf( str, 50, "%lu", settings.width );
		setup_file.set_key( "GRAPHTOOL_WIDTH", str );

		settings.height = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(spinheight));
		snprintf( str, 50, "%lu", settings.height );
		setup_file.set_key( "GRAPHTOOL_HEIGHT", str );

		snprintf( str2, 10, "%02lx%02lx%02lx", settings.bgcolor.red, settings.bgcolor.green, settings.bgcolor.blue );
		setup_file.set_key( "GRAPHTOOL_BGCOLOR", str2 );

		settings.xmin = gtk_entry_get_text(GTK_ENTRY(entryxmin));
		setup_file.set_key( "GRAPHTOOL_XMIN", settings.xmin );
		settings.xmax = gtk_entry_get_text(GTK_ENTRY(entryxmax));
		setup_file.set_key( "GRAPHTOOL_XMAX", settings.xmax );
		settings.ymin = gtk_entry_get_text(GTK_ENTRY(entryymin));
		setup_file.set_key( "GRAPHTOOL_YMIN", settings.ymin );
		settings.ymax = gtk_entry_get_text(GTK_ENTRY(entryymax));
		setup_file.set_key( "GRAPHTOOL_YMAX", settings.ymax );

		settings.axes_on = (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(checkaxes)) == TRUE) ? true : false;
		setup_file.set_key( "GRAPHTOOL_AXES_ON", settings.axes_on ? "True" : "False" );

		snprintf( str2, 10, "%02lx%02lx%02lx", settings.axes_color.red, settings.axes_color.green, settings.axes_color.blue );
		setup_file.set_key( "GRAPHTOOL_AXES_COLOR", str2 );

		settings.grid_on = (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(checkgrid)) == TRUE) ? true : false;
		setup_file.set_key( "GRAPHTOOL_GRID_ON", settings.grid_on ? "True" : "False" );

		snprintf( str2, 10, "%02lx%02lx%02lx", settings.grid_color.red, settings.grid_color.green, settings.grid_color.blue );
		setup_file.set_key( "GRAPHTOOL_GRID_COLOR", str2 );

		setup_file.set_key( "GRAPHTOOL_GRID_SCALE1", settings.grid_scale1 );
		setup_file.set_key( "GRAPHTOOL_GRID_SCALE2", settings.grid_scale2 );
		setup_file.set_key( "GRAPHTOOL_GRID_TYPE", settings.grid_type );
		setup_file.set_key( "GRAPHTOOL_AXES_SCALEX", settings.scalex );
		setup_file.set_key( "GRAPHTOOL_AXES_SCALEY", settings.scaley );
		snprintf( str, 50, "%ld", settings.scale_length );
		setup_file.set_key( "GRAPHTOOL_AXES_SCALE_LENGTH", str );

		setup_file.set_key( "GRAPHTOOL_SHOW_CODE", settings.show_code ? "True" : "False" );

		setup_file.set_key( "GRAPHTOOL_ANTIALIASING", settings.use_antialiasing ? "True" : "False" );

		setup_file.set_key( "GRAPHTOOL_PLOT_MODE", settings.plot_mode );

		setup_file.set_key( "GRAPHTOOL_SHOW_ACTIVE_PAGE_ONLY", settings.show_active_page_only ? "True" : "False" );

		settings.active_page = gtk_notebook_get_current_page(GTK_NOTEBOOK(notebook));
		snprintf( str, 50, "%ld", settings.active_page );
		setup_file.set_key( "GRAPHTOOL_ACTIVE_PAGE", str );


		settings.polar_start = gtk_entry_get_text(GTK_ENTRY(polarentrystart));
		setup_file.set_key( "GRAPHTOOL_POLAR_START", settings.polar_start );

		settings.polar_stop = gtk_entry_get_text(GTK_ENTRY(polarentrystop));
		setup_file.set_key( "GRAPHTOOL_POLAR_STOP", settings.polar_stop );

		settings.polar_steps = gtk_entry_get_text(GTK_ENTRY(polarentrystep));
		setup_file.set_key( "GRAPHTOOL_POLAR_STEPS", settings.polar_steps );

		settings.par_start = gtk_entry_get_text(GTK_ENTRY(parentrystart));
		setup_file.set_key( "GRAPHTOOL_PAR_START", settings.par_start );

		settings.par_stop = gtk_entry_get_text(GTK_ENTRY(parentrystop));
		setup_file.set_key( "GRAPHTOOL_PAR_STOP", settings.par_stop );

		settings.par_steps = gtk_entry_get_text(GTK_ENTRY(parentrystep));
		setup_file.set_key( "GRAPHTOOL_PAR_STEPS", settings.par_steps );

		for(int i=0;i<10;i++)
		{
			settings.func[i].show_this =  (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(func[i].check)) == TRUE) ? true : false;
			snprintf( str, 50, "GRAPHTOOL_Y%lu_SHOW", i );
			setup_file.set_key( str, settings.func[i].show_this ? "True" : "False" );

			settings.func[i].entry = gtk_entry_get_text(GTK_ENTRY(func[i].entry));
			snprintf( str, 50, "GRAPHTOOL_Y%lu_ENTRY", i );
			setup_file.set_key( str, settings.func[i].entry );

			settings.func[i].color = func[i].colorpic.get_pixel(0,0);
			snprintf( str, 50, "GRAPHTOOL_Y%lu_COLOR", i );
			snprintf( str2, 10, "%02lx%02lx%02lx", settings.func[i].color.red, settings.func[i].color.green, settings.func[i].color.blue );
			setup_file.set_key( str, str2 );

			settings.polar[i].show_this = (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(polar[i].check)) == TRUE) ? true : false;
			snprintf( str, 50, "GRAPHTOOL_R%lu_SHOW", i );
			setup_file.set_key( str, settings.polar[i].show_this ? "True" : "False" );

			settings.polar[i].entry = gtk_entry_get_text(GTK_ENTRY(polar[i].entry));
			snprintf( str, 50, "GRAPHTOOL_R%lu_ENTRY", i );
			setup_file.set_key( str, settings.polar[i].entry );

			settings.polar[i].color = polar[i].colorpic.get_pixel(0,0);
			snprintf( str, 50, "GRAPHTOOL_R%lu_COLOR", i );
			snprintf( str2, 10, "%02lx%02lx%02lx", settings.polar[i].color.red, settings.polar[i].color.green, settings.polar[i].color.blue );
			setup_file.set_key( str, str2 );

			if(i < 5)
			{
				settings.par[i].show_this = (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(par[i].check)) == TRUE) ? true : false;
				snprintf( str, 50, "GRAPHTOOL_XF%lu_SHOW", i );
				setup_file.set_key( str, settings.par[i].show_this ? "True" : "False" );

				settings.par[i].entry = gtk_entry_get_text(GTK_ENTRY(par[i].entry));
				snprintf( str, 50, "GRAPHTOOL_XF%lu_ENTRY", i );
				setup_file.set_key( str, settings.par[i].entry );

				settings.par[i].entry2 = gtk_entry_get_text(GTK_ENTRY(par[i].entry2));
				snprintf( str, 50, "GRAPHTOOL_YF%lu_ENTRY", i );
				setup_file.set_key( str, settings.par[i].entry2 );

				settings.par[i].color = par[i].colorpic.get_pixel(0,0);
				snprintf( str, 50, "GRAPHTOOL_XF%lu_COLOR", i );
				snprintf( str2, 10, "%02lx%02lx%02lx", settings.par[i].color.red, settings.par[i].color.green, settings.par[i].color.blue );
				setup_file.set_key( str, str2 );
			}
		}

		gtk_widget_destroy( graphwin );
		graphwin = 0;

		open_windows &= ~GRAPHTOOL_WIN;
		if(open_windows == 0)
			UMP_gtk_quit();
	}
}


























GtkWidget *graphwin_settings,*plot_mode,*show_code,*scalex,*scaley,*scale_length,
          *bgcolor, *axes_color, *grid_color, *grid_scale1, *grid_scale2, *grid_type,
          *show_active_page_only, *antialiasing;


void graphwin_settings_close(void)
{
	gtk_widget_destroy( graphwin_settings );
}
void graphwin_settings_ok(void)
{
	GdkColor tmpcolor;

	if(gtk_combo_box_get_active(GTK_COMBO_BOX(grid_type)) == 0)
		settings.grid_type = "Rect";
	else
		settings.grid_type = "Polar";
	switch( gtk_combo_box_get_active(GTK_COMBO_BOX(plot_mode)) )
	{
	case 0:
		settings.plot_mode = "Dots";
		break;
	case 1:
		settings.plot_mode = "Connected";
		break;
	default:
		settings.plot_mode = "Connected without asymptotes";
		break;
	}

	settings.show_code = (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(show_code)) == TRUE) ? 
	                                                               true : false;

	settings.show_active_page_only = (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(show_active_page_only)) == TRUE)
	                                                       ? true : false;

	settings.use_antialiasing = (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(antialiasing)) == TRUE)
	                                                ? true : false;

	gtk_color_button_get_color(GTK_COLOR_BUTTON(bgcolor), &tmpcolor);
	gdkcolor_to_colorrgb( tmpcolor, settings.bgcolor );
	gtk_color_button_get_color(GTK_COLOR_BUTTON(axes_color), &tmpcolor);
	gdkcolor_to_colorrgb( tmpcolor, settings.axes_color );
	gtk_color_button_get_color(GTK_COLOR_BUTTON(grid_color), &tmpcolor);
	gdkcolor_to_colorrgb( tmpcolor, settings.grid_color );

	settings.scalex = gtk_entry_get_text(GTK_ENTRY(scalex));
	settings.scaley = gtk_entry_get_text(GTK_ENTRY(scaley));
	settings.scale_length = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(scale_length));


	settings.grid_scale1 = gtk_entry_get_text(GTK_ENTRY(grid_scale1));
	settings.grid_scale2 = gtk_entry_get_text(GTK_ENTRY(grid_scale2));

	settings.grid_type = (gtk_combo_box_get_active(GTK_COMBO_BOX(grid_type)) == 0) ?
	                                                                "Rect" : "Polar";

	graphwin_settings_close();
}

void grid_type_changed(GtkComboBox *combobox)
{
	if(gtk_combo_box_get_active(GTK_COMBO_BOX(grid_type)) == 0)
	{
		gtk_entry_set_text( GTK_ENTRY(grid_scale1), "2" );
		gtk_entry_set_text( GTK_ENTRY(grid_scale2), "2" );
	}
	else
	{
		try
		{
			utf8_string str;

			gtk_entry_set_text( GTK_ENTRY(grid_scale1), "2" );

			floatx_to_string( asinx(1.0) / (floatx(math::degfix.real) * 3.0), str, format );

			gtk_entry_set_text( GTK_ENTRY(grid_scale2), str.c_str() );
		}
		catch(...) { }
	}
}

void graphwin_settings_show(void)
{
	GtkWidget *box, *box2, *tmp;
	GtkAdjustment *adj;
	GdkColor color;
	GtkTooltips *tooltips;

	tooltips = gtk_tooltips_new();

	graphwin_settings = gtk_window_new(GTK_WINDOW_TOPLEVEL);

	gtk_window_set_title(GTK_WINDOW(graphwin_settings), _("More settings") );
	g_signal_connect_swapped(GTK_OBJECT(graphwin_settings), "delete-event", G_CALLBACK(graphwin_settings_close), NULL);
	gtk_container_set_border_width( GTK_CONTAINER(graphwin_settings), 2 );

	box = gtk_vbox_new(FALSE,0);

	{
		GtkWidget *frame,*align,*vbox,*hbox;

		frame = gtk_frame_new( _("General") );
		gtk_box_pack_start( GTK_BOX(box), frame, FALSE, FALSE, 2 );

		align = gtk_alignment_new( 0.5, 0.5, 1.0, 1.0 );
		gtk_alignment_set_padding( GTK_ALIGNMENT(align), 3, 3, 12, 3 );
		gtk_container_add( GTK_CONTAINER(frame), align );

		vbox = gtk_vbox_new( FALSE, 0 );
		gtk_container_add( GTK_CONTAINER(align), vbox );

		hbox = gtk_hbox_new( FALSE, 0 );
		gtk_box_pack_start( GTK_BOX(vbox), hbox, FALSE, FALSE, 0 );

		tmp = gtk_label_new_with_mnemonic( _("Background color: ") );
		gtk_misc_set_alignment( GTK_MISC(tmp), 0.0, 0.5 );
		gtk_box_pack_start( GTK_BOX(hbox), tmp, FALSE, FALSE, 0 );

		colorrgb_to_gdkcolor( settings.bgcolor, color );
		bgcolor = gtk_color_button_new_with_color( &color );
		gtk_color_button_set_title( GTK_COLOR_BUTTON(bgcolor), NULL );
		gtk_label_set_mnemonic_widget( GTK_LABEL(tmp), bgcolor );
		gtk_box_pack_start( GTK_BOX(hbox), bgcolor, TRUE, TRUE, 0 );

		show_code = gtk_check_button_new_with_mnemonic( _("_Show code") );
		gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(show_code), (settings.show_code) ? TRUE : FALSE );
		gtk_box_pack_start( GTK_BOX(vbox), show_code, FALSE, FALSE, 0 );

		show_active_page_only = gtk_check_button_new_with_mnemonic( _("Show _active page only") );
		gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(show_active_page_only), 
		                              (settings.show_active_page_only) ? TRUE : FALSE );
		gtk_box_pack_start( GTK_BOX(vbox), show_active_page_only, FALSE, FALSE, 0 );

		antialiasing = gtk_check_button_new_with_mnemonic( _("Antialiasing") );
		gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(antialiasing), 
		                              (settings.use_antialiasing) ? TRUE : FALSE );
		gtk_box_pack_start( GTK_BOX(vbox), antialiasing, FALSE, FALSE, 0 );

		hbox = gtk_hbox_new( FALSE, 0 );
		gtk_box_pack_start( GTK_BOX(vbox), hbox, FALSE, FALSE, 0 );

		tmp = gtk_label_new_with_mnemonic( _("_Plot mode: ") );
		gtk_misc_set_alignment( GTK_MISC(tmp), 0.0, 0.5 );
		gtk_box_pack_start( GTK_BOX(hbox), tmp, FALSE, FALSE, 0 );

		plot_mode = gtk_combo_box_new_text();
		gtk_combo_box_append_text( GTK_COMBO_BOX(plot_mode), _("Dots") );
		gtk_combo_box_append_text( GTK_COMBO_BOX(plot_mode), _("Connected") );
		gtk_combo_box_append_text( GTK_COMBO_BOX(plot_mode), _("Connected without asymptotes") );
		if( settings.plot_mode == "Dots" )
			gtk_combo_box_set_active( GTK_COMBO_BOX(plot_mode), 0 );
		else if(settings.plot_mode == "Connected" )
			gtk_combo_box_set_active( GTK_COMBO_BOX(plot_mode), 1 );
		else
			gtk_combo_box_set_active( GTK_COMBO_BOX(plot_mode), 2 );
		gtk_label_set_mnemonic_widget( GTK_LABEL(tmp), plot_mode );
		gtk_box_pack_start( GTK_BOX(hbox), plot_mode, TRUE, TRUE, 0 );
	}

	{
		GtkWidget *frame,*align,*table;

		frame = gtk_frame_new( _("Axes") );
		gtk_box_pack_start( GTK_BOX(box), frame, FALSE, FALSE, 2 );

		align = gtk_alignment_new( 0.5, 0.5, 1.0, 1.0 );
		gtk_alignment_set_padding( GTK_ALIGNMENT(align), 3, 3, 12, 3 );
		gtk_container_add( GTK_CONTAINER(frame), align );

		table = gtk_table_new( 4, 2, FALSE );
		gtk_container_add( GTK_CONTAINER(align), table );

		tmp = gtk_label_new_with_mnemonic( _("Color: ") );
		gtk_misc_set_alignment( GTK_MISC(tmp), 0.0, 0.5 );
		gtk_table_attach( GTK_TABLE (table), tmp, 0, 1, 0, 1, GTK_FILL,
		                  GtkAttachOptions(0), 1, 1 );

		colorrgb_to_gdkcolor( settings.axes_color, color );
		axes_color = gtk_color_button_new_with_color( &color );
		gtk_color_button_set_title( GTK_COLOR_BUTTON(axes_color), NULL );
		gtk_label_set_mnemonic_widget( GTK_LABEL(tmp), axes_color );
		gtk_table_attach( GTK_TABLE(table), axes_color, 1, 2, 0, 1,
		                  GtkAttachOptions(GTK_FILL | GTK_EXPAND),
		                  GtkAttachOptions(0), 1, 1 );

		tmp = gtk_label_new_with_mnemonic( _("Scale X-axis: ") );
		gtk_misc_set_alignment( GTK_MISC(tmp), 0.0, 0.5 );
		gtk_table_attach( GTK_TABLE(table), tmp, 0, 1, 1, 2, GTK_FILL,
		                  GtkAttachOptions(0), 1, 1 );

		scalex = gtk_entry_new();
		gtk_entry_set_max_length( GTK_ENTRY(scalex), 20);
		gtk_entry_set_text( GTK_ENTRY(scalex), settings.scalex.c_str() );
		gtk_label_set_mnemonic_widget( GTK_LABEL(tmp), scalex );
		gtk_table_attach( GTK_TABLE(table), scalex, 1, 2, 1, 2,
		                  GtkAttachOptions(GTK_FILL | GTK_EXPAND),
		                  GtkAttachOptions(0), 1, 1 );

		tmp = gtk_label_new_with_mnemonic( _("Scale Y-axis: ") );
		gtk_misc_set_alignment( GTK_MISC(tmp), 0.0, 0.5 );
		gtk_table_attach( GTK_TABLE(table), tmp, 0, 1, 2, 3, GTK_FILL,
		                  GtkAttachOptions(0), 1, 1 );

		scaley = gtk_entry_new();
		gtk_entry_set_max_length( GTK_ENTRY(scaley), 20);
		gtk_entry_set_text( GTK_ENTRY(scaley), settings.scaley.c_str() );
		gtk_label_set_mnemonic_widget( GTK_LABEL(tmp), scaley );
		gtk_table_attach( GTK_TABLE(table), scaley, 1, 2, 2, 3,
		                  GtkAttachOptions(GTK_FILL | GTK_EXPAND),
		                  GtkAttachOptions(0), 1,  1);

		tmp = gtk_label_new_with_mnemonic( _("Length of scale marks: ") );
		gtk_misc_set_alignment( GTK_MISC(tmp), 0.0, 0.5 );
		gtk_table_attach( GTK_TABLE(table), tmp, 0, 1, 3, 4, GTK_FILL,
		                  GtkAttachOptions(0), 1, 1);

		adj = (GtkAdjustment *) gtk_adjustment_new(settings.scale_length, 0, 100, 1, 5, 5);
		scale_length = gtk_spin_button_new(adj, 1, 0);
		gtk_label_set_mnemonic_widget(GTK_LABEL(tmp),scale_length);
		gtk_table_attach( GTK_TABLE(table), scale_length, 1, 2, 3, 4,
		                  GtkAttachOptions(GTK_FILL | GTK_EXPAND),
		                  GtkAttachOptions(0), 1, 1 );
	}

	{
		GtkWidget *frame,*align,*table;

		frame = gtk_frame_new( _("Grid") );
		gtk_box_pack_start(GTK_BOX(box),frame,FALSE,FALSE,2);

		align = gtk_alignment_new( 0.5, 0.5, 1.0, 1.0 );
		gtk_alignment_set_padding( GTK_ALIGNMENT(align), 3, 3, 12, 3 );
		gtk_container_add( GTK_CONTAINER(frame), align);

		table = gtk_table_new( 4, 2, FALSE );
		gtk_container_add( GTK_CONTAINER(align), table );

		tmp = gtk_label_new_with_mnemonic( _("Color: ") );
		gtk_misc_set_alignment( GTK_MISC(tmp), 0.0, 0.5 );
		gtk_table_attach( GTK_TABLE(table), tmp, 0, 1, 0, 1, GTK_FILL,
		                  GtkAttachOptions(0), 1, 1 );

		colorrgb_to_gdkcolor( settings.grid_color, color );
		grid_color = gtk_color_button_new_with_color( &color );
		gtk_color_button_set_title( GTK_COLOR_BUTTON(grid_color), NULL );
		gtk_label_set_mnemonic_widget( GTK_LABEL(tmp), grid_color );
		gtk_table_attach( GTK_TABLE(table), grid_color, 1, 2, 0, 1,
		                  GtkAttachOptions(GTK_FILL | GTK_EXPAND),
		                  GtkAttachOptions(0), 1, 1 );

		tmp = gtk_label_new_with_mnemonic( _("Type: ") );
		gtk_misc_set_alignment( GTK_MISC(tmp), 0.0, 0.5 );
		gtk_table_attach( GTK_TABLE(table), tmp, 0, 1, 1, 2, GTK_FILL,
		                  GtkAttachOptions(0), 1, 1 );

		grid_type = gtk_combo_box_new_text();
		gtk_table_attach( GTK_TABLE(table), grid_type, 1, 2, 1, 2,
		                  GtkAttachOptions(GTK_FILL | GTK_EXPAND), GTK_FILL, 0, 0 );
		gtk_combo_box_append_text( GTK_COMBO_BOX(grid_type), _("Rectangular") );
		gtk_combo_box_append_text( GTK_COMBO_BOX(grid_type), _("Polar") );
		if(settings.grid_type == "Rect")
			gtk_combo_box_set_active( GTK_COMBO_BOX(grid_type), 0 );
		else
			gtk_combo_box_set_active( GTK_COMBO_BOX(grid_type), 1 );
		g_signal_connect_swapped(GTK_OBJECT(grid_type), "changed", G_CALLBACK(grid_type_changed), NULL);

		tmp = gtk_label_new_with_mnemonic( _("Scale 1: ") );
		gtk_misc_set_alignment( GTK_MISC(tmp), 0.0, 0.5 );
		gtk_table_attach( GTK_TABLE(table), tmp, 0, 1, 2, 3, GTK_FILL,
		                  GtkAttachOptions(0), 1, 1 );

		grid_scale1 = gtk_entry_new();
		gtk_entry_set_max_length( GTK_ENTRY(grid_scale1), 20);
		gtk_entry_set_text( GTK_ENTRY(grid_scale1), settings.grid_scale1.c_str() );
		gtk_label_set_mnemonic_widget( GTK_LABEL(tmp), grid_scale1 );
		gtk_table_attach( GTK_TABLE(table), grid_scale1, 1, 2, 2, 3,
		                  GtkAttachOptions(GTK_FILL | GTK_EXPAND), GtkAttachOptions(0), 1, 1);
		gtk_tooltips_set_tip( tooltips, grid_scale1,
		       _("In the rectangulary mode this is the X scale,\nelse this is the 'radial' scale."),
		                     NULL );

		tmp = gtk_label_new_with_mnemonic( _("Scale 2: ") );
		gtk_misc_set_alignment( GTK_MISC(tmp), 0.0, 0.5 );
		gtk_table_attach( GTK_TABLE(table), tmp, 0, 1, 3, 4, GTK_FILL,
		                  GtkAttachOptions(0), 1, 1 );

		grid_scale2 = gtk_entry_new();
		gtk_entry_set_max_length( GTK_ENTRY(grid_scale2), 20);
		gtk_entry_set_text( GTK_ENTRY(grid_scale2), settings.grid_scale2.c_str() );
		gtk_label_set_mnemonic_widget( GTK_LABEL(tmp), grid_scale2 );
		gtk_table_attach( GTK_TABLE(table), grid_scale2, 1, 2, 3, 4,
		                  GtkAttachOptions(GTK_FILL | GTK_EXPAND), GtkAttachOptions(0), 1, 1 );
		gtk_tooltips_set_tip( tooltips, grid_scale2,
		       _("In the rectangulary mode this is the Y scale,\nelse this is the 'degree' scale."),
		                      NULL );
	}


	box2 = gtk_hbox_new(FALSE,0);
	{
		GtkWidget *tmpimg,*tmpbox,*tmplabel;
		tmpimg = gtk_image_new_from_stock( GTK_STOCK_OK, GTK_ICON_SIZE_BUTTON );

		tmplabel = gtk_label_new_with_mnemonic(button_ok);

		tmpbox = gtk_hbox_new(FALSE,0);
		gtk_box_pack_start( GTK_BOX(tmpbox), tmpimg, FALSE, FALSE, 2 );
		gtk_box_pack_start( GTK_BOX(tmpbox), tmplabel, FALSE, FALSE, 2 );
		tmp = gtk_button_new();
		gtk_container_add(GTK_CONTAINER(tmp),tmpbox);
	}
	g_signal_connect_swapped( GTK_OBJECT(tmp), "clicked", G_CALLBACK(graphwin_settings_ok), NULL);
	gtk_box_pack_end( GTK_BOX(box2), tmp, FALSE, FALSE, 2 );
	{
		GtkWidget *tmpimg,*tmpbox,*tmplabel;
		tmpimg = gtk_image_new_from_stock( GTK_STOCK_CANCEL, GTK_ICON_SIZE_BUTTON );

		tmplabel = gtk_label_new_with_mnemonic(button_cancel);

		tmpbox = gtk_hbox_new(FALSE,0);
		gtk_box_pack_start( GTK_BOX(tmpbox), tmpimg, FALSE, FALSE, 2 );
		gtk_box_pack_start( GTK_BOX(tmpbox), tmplabel, FALSE, FALSE, 2 );
		tmp = gtk_button_new();
		gtk_container_add( GTK_CONTAINER(tmp), tmpbox );
	}
	g_signal_connect_swapped( GTK_OBJECT(tmp), "clicked", G_CALLBACK(graphwin_settings_close), NULL );
	gtk_box_pack_end( GTK_BOX(box2), tmp, FALSE, FALSE, 2 );

	gtk_box_pack_start( GTK_BOX(box), box2, FALSE, FALSE, 2 );


	gtk_window_set_modal( GTK_WINDOW(graphwin_settings), TRUE );
	gtk_window_set_transient_for( GTK_WINDOW(graphwin_settings), GTK_WINDOW(graphwin) );
	gtk_container_add( GTK_CONTAINER(graphwin_settings), box );
	gtk_widget_show_all(graphwin_settings);
}
