
/*
 *  Ump - Unnamed Math Program
 *  Copyright (c) 2004-2006 by Mattias Hultgren <mattias_hultgren@tele2.se>
 *
 *  See main.cpp
 */

#include <gtk/gtk.h>
#include "math2.h"
#include "picture.h"
#include "picture2gtk.h"
#include "main.h"
#include "ump_prefwin.h"
#include "ump_picturewin.h"


GtkWidget *prefwin = 0;
GtkWidget *pref_format_spinner, *pref_format_trailing, *pref_format_type[3], *pref_snap_size;
GtkWidget *pref_general_language, *pref_general_start_window;

struct UMP_prefwin_pref
{
	GtkWidget *notebook;

	GtkWidget *general_translation_label, *general_start_window_label;

	GtkWidget *format_max_decimals_label, *format_frame_decimals, *format_frame_fractions,
	          *format_frame_frac_show_as;
	GtkWidget *format_fraction_type[3];
	
	GtkWidget *auto_add, *auto_remove, *auto_up, *auto_down, *auto_treeview;
	GtkTreeViewColumn *auto_column;
	GtkListStore *auto_list_store;

	GtkWidget *snap_size_label, *snap_frame;

	GtkWidget *button_ok_label;
}pref;

enum { AUTO_COLUMN_PATH, AUTO_N_COLUMNS };



void prefwin_ok(void)
{
	if( language_filename != gtk_entry_get_text(GTK_ENTRY(GTK_BIN(pref_general_language)->child)) )
		update_translation( gtk_entry_get_text(GTK_ENTRY(GTK_BIN(pref_general_language)->child)) );

	format.set_max_decimals( gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(pref_format_spinner)) );
	format.set_mixed_limits( 1e-6, 1e9 );

	format.show_trailingzeros = 
	  ( gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(pref_format_trailing)) == TRUE );

	for(int i=0;i<3;i++)
	{
		if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(pref_format_type[i])) == TRUE)
			format.set_type( FormatType(i) );

		if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(pref.format_fraction_type[i])) == TRUE)
			format.set_fraction_type( FormatFractionType(i) );
	}

	switch(gtk_combo_box_get_active(GTK_COMBO_BOX(pref_general_start_window)))
	{
	case 0:
		default_start_window = "Simple";
		break;
	case 1:
		default_start_window = "Advanced";
		break;
	case 2:
		default_start_window = "Editor";
		break;
	case 3:
		default_start_window = "Graphtool";
		break;
	case 4:
		default_start_window = "MatrixEditor";
		break;
	}
	SNAP_SIZE = gtk_spin_button_get_value_as_int( GTK_SPIN_BUTTON(pref_snap_size) );

	prefwin_close();
}

void language_changed(GtkComboBox *combobox)
{
	update_translation( gtk_entry_get_text(GTK_ENTRY(GTK_BIN(pref_general_language)->child)), false );

	gtk_window_set_title(GTK_WINDOW(prefwin), _("Preferences") );

	gtk_label_set_text_with_mnemonic( GTK_LABEL(pref.button_ok_label), button_ok );

// translates general-page
	gtk_notebook_set_tab_label( GTK_NOTEBOOK(pref.notebook),
	                            gtk_notebook_get_nth_page(GTK_NOTEBOOK(pref.notebook), 0),
	                            gtk_label_new_with_mnemonic( _("_General") ) );

	gtk_label_set_text_with_mnemonic(GTK_LABEL(pref.general_translation_label), _("_Translation: ") );

	gtk_label_set_text_with_mnemonic( GTK_LABEL(pref.general_start_window_label), _("Start _window: ") );

	{
		gint i = gtk_combo_box_get_active(GTK_COMBO_BOX(pref_general_start_window));

		gtk_combo_box_append_text( GTK_COMBO_BOX(pref_general_start_window), 
		                           _("Simple calculator") );
		gtk_combo_box_append_text( GTK_COMBO_BOX(pref_general_start_window),
		                           _("Advanced calculator") );
		gtk_combo_box_append_text( GTK_COMBO_BOX(pref_general_start_window), _("UMP-editor") );
		gtk_combo_box_append_text( GTK_COMBO_BOX(pref_general_start_window), _("Graph tools") );
		gtk_combo_box_append_text( GTK_COMBO_BOX(pref_general_start_window), _("Matrix editor") );

		for(int o=0;o<5;o++)  // removing the five first...
			gtk_combo_box_remove_text(GTK_COMBO_BOX(pref_general_start_window), 0);

		gtk_combo_box_set_active( GTK_COMBO_BOX(pref_general_start_window), i );
	}
// general-page is now translated


// translates number-format-page
	gtk_notebook_set_tab_label( GTK_NOTEBOOK(pref.notebook),
	                            gtk_notebook_get_nth_page(GTK_NOTEBOOK(pref.notebook), 1),
	                            gtk_label_new_with_mnemonic( _("_Number format") ) );

	gtk_frame_set_label( GTK_FRAME(pref.format_frame_decimals), _("Decimals") );
	gtk_button_set_label( GTK_BUTTON(pref_format_type[0]), _("No_rmal") );
	gtk_button_set_label( GTK_BUTTON(pref_format_type[1]), _("Mi_xed") );
	gtk_button_set_label( GTK_BUTTON(pref_format_type[2]), _("_Science") );

	gtk_label_set_text_with_mnemonic( GTK_LABEL(pref.format_max_decimals_label),
	                                  _("Max _decimals: ") );

	gtk_button_set_label( GTK_BUTTON(pref_format_trailing), _("Show trailing _zeros") );


	gtk_frame_set_label( GTK_FRAME(pref.format_frame_fractions), _("Fractions") );

	gtk_frame_set_label( GTK_FRAME(pref.format_frame_frac_show_as), _("Show as...") );

	gtk_button_set_label( GTK_BUTTON(pref.format_fraction_type[0]), _("fractions") );
	gtk_button_set_label( GTK_BUTTON(pref.format_fraction_type[1]), _("integer + fraction") );
	gtk_button_set_label( GTK_BUTTON(pref.format_fraction_type[2]), _("decimals") );
// number-format-page is now translated

// autoloading page	
	gtk_notebook_set_tab_label( GTK_NOTEBOOK(pref.notebook),
	                            gtk_notebook_get_nth_page(GTK_NOTEBOOK(pref.notebook), 2),
	                            gtk_label_new_with_mnemonic( _("_Autoloading") ) );

	gtk_button_set_label( GTK_BUTTON(pref.auto_add), _("Add") );
	gtk_button_set_label( GTK_BUTTON(pref.auto_remove), _("Remove") );
	gtk_button_set_label( GTK_BUTTON(pref.auto_up), _("Move up") );
	gtk_button_set_label( GTK_BUTTON(pref.auto_down), _("Move down") );

	gtk_tree_view_column_set_title( GTK_TREE_VIEW_COLUMN(pref.auto_column), _("Path") );
// autoloading page is now translated

// snap page	
	gtk_notebook_set_tab_label( GTK_NOTEBOOK(pref.notebook),
	                            gtk_notebook_get_nth_page(GTK_NOTEBOOK(pref.notebook), 3),
	                            gtk_label_new_with_mnemonic( _("_Snaping") ) );

	gtk_frame_set_label( GTK_FRAME(pref.snap_frame), _("Snaping") );
	gtk_label_set_text_with_mnemonic( GTK_LABEL(pref.snap_size_label),
	                                  _("Snap size: ") );
// snap page is now translated
}

void prefwin_browse_button(GtkButton *button,gpointer user_data)
{
	GtkWidget *file_chooser, *tmp=GTK_WIDGET(user_data);

	if( tmp == pref_general_language )
	{
		file_chooser = gtk_file_chooser_dialog_new( dialog_title_open_file, GTK_WINDOW(prefwin),
		                                            GTK_FILE_CHOOSER_ACTION_OPEN,
		                                            GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
		                                            GTK_STOCK_OPEN, GTK_RESPONSE_ACCEPT, NULL );

		gtk_file_chooser_set_filename( GTK_FILE_CHOOSER(file_chooser),
		                   gtk_entry_get_text(GTK_ENTRY(GTK_BIN(pref_general_language)->child)) );
	}
	else
		file_chooser = gtk_file_chooser_dialog_new( dialog_title_open_file, GTK_WINDOW(prefwin),
		                                            GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER,
		                                            GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
		                                            GTK_STOCK_OPEN, GTK_RESPONSE_ACCEPT, NULL );
		


	if(gtk_dialog_run(GTK_DIALOG(file_chooser)) == GTK_RESPONSE_ACCEPT)
	{
		char *filename = gtk_file_chooser_get_filename(GTK_FILE_CHOOSER(file_chooser));

		if( tmp == pref_general_language )
			gtk_entry_set_text( GTK_ENTRY(GTK_BIN(pref_general_language)->child), filename );
		else // autoloading -> add
		{
			utf8_string file(filename);
			GtkTreeIter iter;
			
			math::autoload_directories.insert( file, 0 );
			gtk_list_store_prepend( pref.auto_list_store, &iter );
			gtk_list_store_set( pref.auto_list_store, &iter, AUTO_COLUMN_PATH, filename, -1 );
		}
		g_free(filename);
	}

	gtk_widget_destroy(file_chooser);
}

void prefwin_auto_remove(GtkButton *button,gpointer user_data)
{
	GtkTreeSelection *sel;
	GtkTreeModel *model;
	GtkTreeIter iter;
	gchar *name;

	sel = gtk_tree_view_get_selection( GTK_TREE_VIEW(pref.auto_treeview) );

	if( gtk_tree_selection_get_selected( sel, &model, &iter ) )
	{
		gtk_tree_model_get( model, &iter, AUTO_COLUMN_PATH, &name, -1 );

		for( int i=0; i<math::autoload_directories.get_size(); i++ )
		{
			if( *math::autoload_directories[i] == name )
			{
				math::autoload_directories.remove(i);
				break;
			}
		}
		
		gtk_list_store_remove( pref.auto_list_store, &iter );

		g_free( name );
	}
}

void prefwin_auto_swap(GtkButton *button,gpointer user_data)
{
	GtkTreeSelection *sel;
	GtkTreeModel *model;
	GtkTreeIter iter, iter2;
	gchar *name;
	int i;

	sel = gtk_tree_view_get_selection( GTK_TREE_VIEW(pref.auto_treeview) );

	if( gtk_tree_selection_get_selected( sel, &model, &iter ) )
	{
		gtk_tree_model_get( model, &iter, AUTO_COLUMN_PATH, &name, -1 );

		for( i=0; i<math::autoload_directories.get_size(); i++ )
		{
			if( *math::autoload_directories[i] == name )
				break;
		}
		
		if( GTK_WIDGET(user_data) == pref.auto_up )
		{
			if( i != 0 )
			{
				math::autoload_directories.swap( i, i-1 );
				
				gtk_tree_model_get_iter_first( model, &iter2 );
				for( int a=0; a<(i-1); a++ )
				{
					if( gtk_tree_model_iter_next( model, &iter2 ) == FALSE )
						return;
				}
				gtk_list_store_swap( pref.auto_list_store, &iter, &iter2 );
			}
		}
		else
		{
			if( i != math::autoload_directories.get_size()-1 )
			{
				math::autoload_directories.swap( i, i+1 );

				iter2 = iter;
				if( gtk_tree_model_iter_next( model, &iter2 ) == TRUE )
					gtk_list_store_swap( pref.auto_list_store, &iter, &iter2 );
			}
		}

		g_free( name );
	}
}

void prefwin_show(GtkWindow *parent)
{
	if(prefwin == 0)
	{
		GtkWidget *vbox,*hbox,*apply,*box,*box2,*tmp,*table;
		GtkAdjustment *spinner_adj;

		prefwin = gtk_window_new(GTK_WINDOW_TOPLEVEL);

		gtk_window_set_title( GTK_WINDOW(prefwin), _("Preferences") );
		gtk_container_set_border_width( GTK_CONTAINER(prefwin), 5 );

		g_signal_connect_swapped( GTK_OBJECT(prefwin), "delete-event", G_CALLBACK(prefwin_ok), NULL );

		vbox = gtk_vbox_new( FALSE, 3 );

		pref.notebook = gtk_notebook_new();

// General page starts
		table = gtk_table_new( 2, 3, FALSE );
		gtk_table_set_row_spacings( GTK_TABLE(table), 3 );
		gtk_table_set_col_spacings( GTK_TABLE(table), 3 );
		gtk_container_set_border_width( GTK_CONTAINER(table), 5 );

		pref.general_translation_label = gtk_label_new_with_mnemonic( _("_Translation: ") );
		gtk_table_attach( GTK_TABLE(table), pref.general_translation_label, 0, 1, 0, 1, GTK_FILL,
		                  GtkAttachOptions(0), 1, 1);
		gtk_misc_set_alignment( GTK_MISC(pref.general_translation_label), 0, 0.5 );

		pref_general_language = gtk_combo_box_entry_new_text();
		gtk_label_set_mnemonic_widget( GTK_LABEL(pref.general_translation_label),
		                               pref_general_language );
		gtk_entry_set_max_length(GTK_ENTRY(GTK_BIN(pref_general_language)->child),200);
		gtk_combo_box_append_text(GTK_COMBO_BOX(pref_general_language), "English");
		gtk_combo_box_append_text(GTK_COMBO_BOX(pref_general_language), "Svenska");
		gtk_entry_set_text(GTK_ENTRY(GTK_BIN(pref_general_language)->child), language_filename.c_str());
		g_signal_connect( GTK_OBJECT(pref_general_language), "changed", 
		                  G_CALLBACK(language_changed), 0 );
		gtk_table_attach( GTK_TABLE(table), pref_general_language, 1, 2, 0, 1,
		                  GtkAttachOptions(GTK_FILL | GTK_EXPAND), GtkAttachOptions(0), 1, 1 );
		{
			GtkWidget *tmpimg;
			tmpimg = gtk_image_new_from_stock( GTK_STOCK_OPEN, GTK_ICON_SIZE_BUTTON );

			tmp = gtk_button_new();
			gtk_container_add(GTK_CONTAINER(tmp),tmpimg);
		}
		g_signal_connect( GTK_OBJECT(tmp), "clicked", G_CALLBACK(prefwin_browse_button), 
		                  gpointer(pref_general_language) );
		gtk_table_attach( GTK_TABLE(table), tmp, 2, 3, 0, 1, GTK_FILL, GtkAttachOptions(0), 1, 1 );


		pref.general_start_window_label = gtk_label_new_with_mnemonic( _("Start _window: ") );
		gtk_table_attach( GTK_TABLE(table), pref.general_start_window_label, 0, 1, 1, 2, GTK_FILL,
		                  GtkAttachOptions(0), 1, 1 );
		gtk_misc_set_alignment(GTK_MISC (pref.general_start_window_label), 0, 0.5);

		pref_general_start_window = gtk_combo_box_new_text();
		gtk_label_set_mnemonic_widget( GTK_LABEL(pref.general_start_window_label),
		                               pref_general_start_window );
		gtk_table_attach( GTK_TABLE(table), pref_general_start_window, 1, 3, 1, 2,
		                  GtkAttachOptions(GTK_FILL | GTK_EXPAND), GTK_FILL, 0, 0 );

		gtk_combo_box_append_text( GTK_COMBO_BOX(pref_general_start_window),
		                           _("Simple calculator") );
		gtk_combo_box_append_text( GTK_COMBO_BOX(pref_general_start_window),
		                           _("Advanced calculator") );
		gtk_combo_box_append_text( GTK_COMBO_BOX(pref_general_start_window), _("UMP-editor") );
		gtk_combo_box_append_text( GTK_COMBO_BOX(pref_general_start_window), _("Graph tools") );
		gtk_combo_box_append_text( GTK_COMBO_BOX(pref_general_start_window), _("Matrix editor") );
		if(default_start_window == "Simple")
			gtk_combo_box_set_active( GTK_COMBO_BOX(pref_general_start_window), 0 );
		else if(default_start_window == "Editor")
			gtk_combo_box_set_active( GTK_COMBO_BOX(pref_general_start_window), 2 );
		else if(default_start_window == "Graphtool")
			gtk_combo_box_set_active( GTK_COMBO_BOX(pref_general_start_window), 3 );
		else if(default_start_window == "MatrixEditor")
			gtk_combo_box_set_active( GTK_COMBO_BOX(pref_general_start_window), 4 );
		else // "Advanced"
			gtk_combo_box_set_active( GTK_COMBO_BOX(pref_general_start_window), 1 );


		tmp = gtk_label_new_with_mnemonic( _("_General") );
		gtk_notebook_append_page(GTK_NOTEBOOK(pref.notebook),table,tmp);
// General page starts

// Number format starts
		box2 = gtk_vbox_new( FALSE, 3 );
		gtk_container_set_border_width(GTK_CONTAINER(box2), 5);


		{  // decimals frame
			pref.format_frame_decimals = gtk_frame_new( _("Decimals") );
			gtk_box_pack_start( GTK_BOX(box2), pref.format_frame_decimals, FALSE, FALSE, 0 );
			gtk_container_set_border_width( GTK_CONTAINER(pref.format_frame_decimals), 5 );


			box = gtk_vbox_new(FALSE,3);
			gtk_container_add( GTK_CONTAINER(pref.format_frame_decimals), box );
			gtk_container_set_border_width( GTK_CONTAINER(box), 5 );


			pref_format_type[0] = gtk_radio_button_new_with_mnemonic( 0, _("No_rmal") );
			pref_format_type[1] = gtk_radio_button_new_with_mnemonic_from_widget(
			  GTK_RADIO_BUTTON(pref_format_type[0]), _("Mi_xed") );
			pref_format_type[2] = gtk_radio_button_new_with_mnemonic_from_widget(
			  GTK_RADIO_BUTTON(pref_format_type[0]), _("_Science") );

			gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(pref_format_type[format.get_type()]),TRUE);

			hbox = gtk_hbox_new(FALSE,3);
			for(int i=0;i<3;i++)
				gtk_box_pack_start(GTK_BOX(hbox), pref_format_type[i], FALSE, FALSE, 0);
			gtk_box_pack_start(GTK_BOX(box), hbox, FALSE, FALSE, 0);

			pref.format_max_decimals_label = gtk_label_new_with_mnemonic( _("Max _decimals: ") );

			spinner_adj = (GtkAdjustment *) gtk_adjustment_new( gdouble(format.get_max_decimals()),
			                                                    0.0, 50.0, 1.0, 5.0, 5.0 );
			pref_format_spinner = gtk_spin_button_new( spinner_adj, 1.0, 0 );
			gtk_label_set_mnemonic_widget( GTK_LABEL(pref.format_max_decimals_label),
			                               pref_format_spinner );

			hbox = gtk_hbox_new( FALSE, 3 );
			gtk_box_pack_start( GTK_BOX(hbox), pref.format_max_decimals_label, FALSE, FALSE, 0 );
			gtk_box_pack_start( GTK_BOX(hbox), pref_format_spinner, FALSE, FALSE, 0 );

			gtk_box_pack_start( GTK_BOX(box), hbox, FALSE, FALSE, 2 );

			pref_format_trailing = gtk_check_button_new_with_mnemonic( _("Show trailing _zeros") );

			gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(pref_format_trailing),
			                              (format.show_trailingzeros) ? TRUE : FALSE );

			gtk_box_pack_start(GTK_BOX(box), pref_format_trailing, FALSE, FALSE, 0);
		} // decimals frame

		{  // fractions frame
			GtkWidget *hbox;

			pref.format_frame_fractions = gtk_frame_new( _("Fractions") );
			gtk_box_pack_start( GTK_BOX(box2), pref.format_frame_fractions, FALSE, FALSE, 0 );

			gtk_container_set_border_width(GTK_CONTAINER(pref.format_frame_fractions), 5);

			pref.format_frame_frac_show_as = gtk_frame_new( _("Show as...") );
			gtk_frame_set_shadow_type( GTK_FRAME(pref.format_frame_frac_show_as), GTK_SHADOW_NONE );
			gtk_container_add( GTK_CONTAINER(pref.format_frame_fractions),
			pref.format_frame_frac_show_as );
			gtk_container_set_border_width(GTK_CONTAINER(pref.format_frame_frac_show_as), 3);

			hbox = gtk_hbox_new( FALSE, 3 );
			gtk_container_add( GTK_CONTAINER(pref.format_frame_frac_show_as), hbox );
			gtk_container_set_border_width(GTK_CONTAINER(hbox), 5);


			pref.format_fraction_type[0] = gtk_radio_button_new_with_mnemonic( 0, _("fractions") );
			pref.format_fraction_type[1] = gtk_radio_button_new_with_mnemonic_from_widget(
			  GTK_RADIO_BUTTON(pref.format_fraction_type[0]), _("integer + fraction") );
			pref.format_fraction_type[2] = gtk_radio_button_new_with_mnemonic_from_widget(
			  GTK_RADIO_BUTTON(pref.format_fraction_type[0]), _("decimals") );

			gtk_toggle_button_set_active(
			   GTK_TOGGLE_BUTTON(pref.format_fraction_type[format.get_fraction_type()]), TRUE );

			for(int i=0;i<3;i++)
				gtk_box_pack_start(GTK_BOX(hbox), pref.format_fraction_type[i], FALSE, FALSE, 0);

		} // fractions frame

		tmp = gtk_label_new_with_mnemonic( _("_Number format") );
		gtk_notebook_append_page(GTK_NOTEBOOK(pref.notebook),box2,tmp);
// Number format ends

// Autoload page starts
		table = gtk_table_new( 4, 2, FALSE );
		gtk_table_set_row_spacings( GTK_TABLE(table), 3 );
		gtk_table_set_col_spacings( GTK_TABLE(table), 3 );
		gtk_container_set_border_width(GTK_CONTAINER(table), 5);

		{
			GtkTreeIter iter;
			GtkCellRenderer *renderer;

			pref.auto_list_store = gtk_list_store_new( AUTO_N_COLUMNS, G_TYPE_STRING );
			
			for( int i=0; i<math::autoload_directories.get_size(); i++ )
			{
				gtk_list_store_append( pref.auto_list_store, &iter );
				gtk_list_store_set( pref.auto_list_store, &iter, AUTO_COLUMN_PATH,
				                    math::autoload_directories[i]->c_str(), -1 );
			}
			pref.auto_treeview = gtk_tree_view_new_with_model( GTK_TREE_MODEL(pref.auto_list_store) );
			gtk_table_attach( GTK_TABLE(table), pref.auto_treeview, 0, 1, 0, 4,
			                  GtkAttachOptions(GTK_EXPAND | GTK_FILL),
			                  GtkAttachOptions(GTK_EXPAND | GTK_FILL), 0, 0 );
			
			renderer = gtk_cell_renderer_text_new();
			pref.auto_column = gtk_tree_view_column_new_with_attributes( _("Path"), renderer, "text",
			                                                             AUTO_COLUMN_PATH, NULL );
			gtk_tree_view_append_column( GTK_TREE_VIEW(pref.auto_treeview), pref.auto_column );
		}
		pref.auto_add = gtk_button_new_with_mnemonic( _("Add") );
		g_signal_connect( GTK_OBJECT(pref.auto_add), "clicked", G_CALLBACK(prefwin_browse_button), 
		                  gpointer(pref.auto_add) );
		gtk_table_attach( GTK_TABLE(table), pref.auto_add, 1, 2, 0, 1, GTK_FILL,
		                  GtkAttachOptions(0), 0, 0 );

		pref.auto_remove = gtk_button_new_with_mnemonic( _("Remove") );
		g_signal_connect( GTK_OBJECT(pref.auto_remove), "clicked", G_CALLBACK(prefwin_auto_remove),
		                  0 );
		gtk_table_attach( GTK_TABLE(table), pref.auto_remove, 1, 2, 1, 2, GTK_FILL,
		                  GtkAttachOptions(0), 0, 0 );

		pref.auto_up = gtk_button_new_with_mnemonic( _("Move up") );
		g_signal_connect( GTK_OBJECT(pref.auto_up), "clicked", G_CALLBACK(prefwin_auto_swap),
		                  gpointer(pref.auto_up) );
		gtk_table_attach( GTK_TABLE(table), pref.auto_up, 1, 2, 2, 3, GTK_FILL,
		                  GtkAttachOptions(0), 0, 0 );

		pref.auto_down = gtk_button_new_with_mnemonic( _("Move down") );
		g_signal_connect( GTK_OBJECT(pref.auto_down), "clicked", G_CALLBACK(prefwin_auto_swap),
		                  gpointer(pref.auto_down) );
		gtk_table_attach( GTK_TABLE(table), pref.auto_down, 1, 2, 3, 4, GTK_FILL,
		                  GtkAttachOptions(0), 0, 0 );

		tmp = gtk_label_new_with_mnemonic( _("_Autoloading") );
		gtk_notebook_append_page( GTK_NOTEBOOK(pref.notebook), table, tmp );
// Autoload page ends
// snaping starts
		box2 = gtk_vbox_new( FALSE, 3 );
		gtk_container_set_border_width(GTK_CONTAINER(box2), 5);


		pref.snap_frame = gtk_frame_new( _("Snaping") );
		gtk_box_pack_start( GTK_BOX(box2), pref.snap_frame, FALSE, FALSE, 0 );
		gtk_container_set_border_width( GTK_CONTAINER(pref.snap_frame), 5 );

		box = gtk_vbox_new( FALSE, 3 );
		gtk_container_add( GTK_CONTAINER(pref.snap_frame), box );
		gtk_container_set_border_width( GTK_CONTAINER(box), 5 );

		pref_snap_size = gtk_spin_button_new_with_range( 0.0, 100.0, 1.0 );
		gtk_spin_button_set_value( GTK_SPIN_BUTTON(pref_snap_size), gdouble(SNAP_SIZE) );
		pref.snap_size_label = gtk_label_new_with_mnemonic( _("Snap size: ") );
		gtk_label_set_mnemonic_widget( GTK_LABEL(pref.snap_size_label), pref_snap_size );


		hbox = gtk_hbox_new( FALSE, 3 );
		gtk_box_pack_start( GTK_BOX(hbox), pref.snap_size_label, FALSE, FALSE, 0 );
		gtk_box_pack_start( GTK_BOX(hbox), pref_snap_size, FALSE, FALSE, 0 );

		gtk_box_pack_start( GTK_BOX(box), hbox, FALSE, FALSE, 2 );

		tmp = gtk_label_new_with_mnemonic( _("_Snaping") );
		gtk_notebook_append_page( GTK_NOTEBOOK(pref.notebook), box2, tmp );
// snaping ends
		gtk_box_pack_start( GTK_BOX(vbox), pref.notebook, TRUE, TRUE, 0 );
		gtk_notebook_set_tab_pos( GTK_NOTEBOOK(pref.notebook), GTK_POS_LEFT );

		{
			GtkWidget *tmpimg,*tmpbox;
			tmpimg = gtk_image_new_from_stock( GTK_STOCK_OK, GTK_ICON_SIZE_BUTTON );

			pref.button_ok_label = gtk_label_new_with_mnemonic(button_ok);

			tmpbox = gtk_hbox_new( FALSE, 0 );
			gtk_box_pack_start( GTK_BOX(tmpbox), tmpimg, FALSE, FALSE, 2 );
			gtk_box_pack_start( GTK_BOX(tmpbox), pref.button_ok_label, FALSE, FALSE, 2 );
			apply = gtk_button_new();
			gtk_container_add( GTK_CONTAINER(apply), tmpbox );
		}
		g_signal_connect_swapped( GTK_OBJECT(apply), "clicked", G_CALLBACK(prefwin_ok), NULL );

		hbox = gtk_hbox_new(FALSE,0);
		gtk_box_pack_end(GTK_BOX(hbox), apply, FALSE, FALSE, 0);


		gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 0);


		gtk_container_add(GTK_CONTAINER(prefwin), vbox);

		gtk_window_set_modal(GTK_WINDOW(prefwin), TRUE);
		if(parent != 0)
			gtk_window_set_transient_for(GTK_WINDOW(prefwin), parent);

		gtk_widget_show_all(prefwin);
	}
	else
		gtk_window_present(GTK_WINDOW(prefwin));
}


void prefwin_close(void)
{
	gtk_widget_destroy(prefwin);
	prefwin = 0;
}
