
/*
 *  Ump - Unnamed Math Program
 *  Copyright (c) 2004-2006 by Mattias Hultgren <mattias_hultgren@tele2.se>
 *
 *  See main.cpp
 */

#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>
#include "ump_simplewin.h"
#include "ump_editor.h"
#include "ump_aboutwin.h"
#include "ump_advancedwin.h"
#include "ump_graphwin.h"
#include "ump_prefwin.h"
#include "matrix_editor.h"
#include "math2.h"
#include "main.h"
#include <string.h>

extern "C"
{
	#include "image_sqrt.c"
}

using math::Variable;


GtkWidget *simplewin = 0, *simplewin_vbox, *simplewin_menu;
GtkWidget *entry, *statusbar;

math::CodeLine simplebrain,simple_intern;
Complex mem;
bool showing_answer,empty_brain;
char count_func[2];

void aboutwin_show_simple(void) { aboutwin_show(GTK_WINDOW(simplewin)); }
void prefwin_show_simple(void) { prefwin_show(GTK_WINDOW(simplewin)); }


void button_CE(void)
{
	gtk_entry_set_text(GTK_ENTRY(entry), "0");
	showing_answer = false;
}
void button_AC(void)
{
	simplebrain.set_code_line(" ");
	empty_brain = true;
	count_func[0] = '\0';
	button_CE();
}
void button_comma(void)
{
	const char *entrytext;
	int i,c;

	if(showing_answer)
		button_CE();

	entrytext = gtk_entry_get_text(GTK_ENTRY(entry));

	for(i=0,c=0;entrytext[i] != '\0';i++)
	{
		if(entrytext[i] == '.')
		c++;
	}
	if(c != 0)
		return;

	gint pos = strlen(entrytext);
	gtk_editable_insert_text(GTK_EDITABLE(entry), ".", 1, &pos);
}
void button0_9(GtkButton *button, gpointer tmp)
{
	char *buttontext = (char *) tmp;
	const char *entrytext;

	if(showing_answer)
		button_CE();

	entrytext = gtk_entry_get_text(GTK_ENTRY(entry));

	if(strcmp("0",entrytext) == 0)
		gtk_entry_set_text(GTK_ENTRY(entry), buttontext);
	else
	{
		gint pos = strlen(entrytext);
		gtk_editable_insert_text(GTK_EDITABLE(entry), buttontext, 1, &pos);
	}
}
void button_count(GtkButton *button, gpointer tmp)
{
	char *buttontext = (char *) tmp;
	const char *entrytext;
	utf8_string tmp_str;


	entrytext = gtk_entry_get_text(GTK_ENTRY(entry));

	try
	{
		if( !showing_answer )
		{
			simplebrain.get_code_line( &tmp_str );
			if(count_func[0] != ' ')
				tmp_str.append( count_func );
			empty_brain = false;
			tmp_str.append( "(" );
			tmp_str.append( entrytext );
			tmp_str.append( ")" );
			simplebrain.set_code_line( tmp_str.c_str() );

			showing_answer = true;

			{
				utf8_string str;
				Variable ans;

				simplebrain.calc( &ans );
				ans.append_to_string( str, *math::intern_format );
				gtk_entry_set_text( GTK_ENTRY(entry), str.c_str() );
			}
		}
		count_func[0] = buttontext[0];
		if( empty_brain )
		{
			simplebrain.get_code_line( &tmp_str );
			tmp_str.append( entrytext );
			simplebrain.set_code_line( tmp_str.c_str() );
			empty_brain = false;
		}
	}
	catch(error_obj error)
	{
		GtkWidget *dialog;
		dialog = gtk_message_dialog_new( GTK_WINDOW(simplewin), GTK_DIALOG_DESTROY_WITH_PARENT,
		                                 GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE, error.msg );
		gtk_dialog_run(GTK_DIALOG(dialog));
		gtk_widget_destroy(dialog);
		return;
	}
	catch(...)
	{
		try{ THROW_ERROR( ErrorType_Memory, _("Couldn't get memory.") ); }
		catch(error_obj error)
		{
			GtkWidget *dialog;
			dialog = gtk_message_dialog_new( GTK_WINDOW(simplewin), GTK_DIALOG_DESTROY_WITH_PARENT,
			                                 GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE, error.msg );
			gtk_dialog_run(GTK_DIALOG(dialog));
			gtk_widget_destroy(dialog);
			return;
		}
	}
}
void button_percent(void)
{
	bool should_do_percent = false;
	char c[2];

	if(count_func[0] == '/')
		should_do_percent = true;

	try
	{
		c[0] = ' ';
		c[1] = '\0';
		button_count( 0, gpointer (c) );

		if(should_do_percent)
		{
			utf8_string str, tmp_str;
			Variable ans;

			simplebrain.get_code_line( &tmp_str );
			tmp_str.append( "*100" );
			simplebrain.set_code_line( tmp_str.c_str() );

			showing_answer = true;

			simplebrain.calc( &ans );
			ans.append_to_string( str, *math::intern_format );
			gtk_entry_set_text( GTK_ENTRY(entry), str.c_str() );
		}

		simplebrain.set_code_line( " " );
		empty_brain = true;
	}
	catch(error_obj error)
	{
		GtkWidget *dialog;
		dialog = gtk_message_dialog_new( GTK_WINDOW(simplewin), GTK_DIALOG_DESTROY_WITH_PARENT,
		                                 GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE, error.msg );
		gtk_dialog_run(GTK_DIALOG(dialog));
		gtk_widget_destroy(dialog);
	}
}
void button_equal(void)
{
	char c[2];

	c[0] = ' ';
	c[1] = '\0';
	button_count( 0, gpointer (c) );

	simplebrain.set_code_line( " " );
	showing_answer = true;
	empty_brain = true;
}
void button_toggle_sign(void)
{
	const char *entrytext;
	char *tmp = 0;

	if(showing_answer)
	{
		if(!empty_brain)
			return;

		showing_answer = false;

		simplebrain.set_code_line( " " );
	}

	entrytext = gtk_entry_get_text(GTK_ENTRY(entry));

	try
	{
		tmp = new char [ strlen(entrytext) + 3];

		if(entrytext[0] == '-')
		{
			for(int i=1;;i++)
			{
				tmp[i-1] = entrytext[i];
				if(entrytext[i] == '\0')
					break;
			}
		}
		else
		{
			tmp[0] = '-';
			for(int i=0;;i++)
			{
				tmp[i+1] = entrytext[i];
				if(entrytext[i] == '\0')
					break;
			}
		}

		gtk_entry_set_text(GTK_ENTRY(entry), tmp);
		delete [] tmp;
	}
	catch(...)
	{
		delete [] tmp;
		try{  THROW_ERROR( ErrorType_Memory, _("Couldn't get memory.") );  }
		catch(error_obj error)
		{
			GtkWidget *dialog;
			dialog = gtk_message_dialog_new( GTK_WINDOW(simplewin), GTK_DIALOG_DESTROY_WITH_PARENT,
			                                 GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE, error.msg );
			gtk_dialog_run(GTK_DIALOG(dialog));
			gtk_widget_destroy(dialog);
			return;
		}
	}
}
void button_bracket_count_before(GtkButton *button, gpointer tmp)
{
	char *buttontext = (char *) tmp;
	const char *entrytext;

	entrytext = gtk_entry_get_text(GTK_ENTRY(entry));

	try
	{
		utf8_string str, tmp_str;
		Variable ans;

		tmp_str = buttontext;
		tmp_str.append( "(" );
		tmp_str.append( entrytext );
		tmp_str.append( ")" );
		
		simple_intern.set_code_line( tmp_str.c_str() );
		simple_intern.calc( &ans );

		ans.append_to_string( str, *math::intern_format );
		gtk_entry_set_text( GTK_ENTRY(entry), str.c_str() );
		showing_answer = true;
		empty_brain = true;
	}
	catch(error_obj error)
	{
		GtkWidget *dialog;
		dialog = gtk_message_dialog_new( GTK_WINDOW(simplewin), GTK_DIALOG_DESTROY_WITH_PARENT,
		                                 GTK_MESSAGE_ERROR,	GTK_BUTTONS_CLOSE, error.msg );
		gtk_dialog_run(GTK_DIALOG(dialog));
		gtk_widget_destroy(dialog);
	}
}
void button_bracket_count_after(GtkButton *button, gpointer tmp)
{
	char *buttontext = (char *) tmp;
	const char *entrytext;

	entrytext = gtk_entry_get_text(GTK_ENTRY(entry));

	try
	{
		utf8_string str, tmp_str;
		Variable ans;

		tmp_str = "(";
		tmp_str.append( entrytext );
		tmp_str.append( ")" );
		tmp_str.append( buttontext );
		simple_intern.set_code_line( tmp_str.c_str() );
		simple_intern.calc( &ans );

		ans.append_to_string( str, *math::intern_format );
		gtk_entry_set_text( GTK_ENTRY(entry), str.c_str() );
		showing_answer = true;
		empty_brain = true;
	}
	catch(error_obj error)
	{
		GtkWidget *dialog;
		dialog = gtk_message_dialog_new( GTK_WINDOW(simplewin), GTK_DIALOG_DESTROY_WITH_PARENT,
		                                 GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE, error.msg );
		gtk_dialog_run( GTK_DIALOG(dialog) );
		gtk_widget_destroy( dialog );
	}
}
void button_mem_clear(void)
{
	mem = Real(0);
}
void button_mem_recall(void)
{
	utf8_string str;
	if(showing_answer)
		button_CE();

	try
	{
		mem.append_to_string( str, *math::intern_format );
		gtk_entry_set_text( GTK_ENTRY(entry), str.c_str() );
	}
	catch(error_obj error)
	{
		GtkWidget *dialog;
		dialog = gtk_message_dialog_new( GTK_WINDOW(simplewin), GTK_DIALOG_DESTROY_WITH_PARENT,
		                                 GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE, error.msg );
		gtk_dialog_run( GTK_DIALOG(dialog) );
		gtk_widget_destroy( dialog );
	}
	button_equal();
}
void button_mem_calc(GtkButton *button, gpointer tmp)
{
	char *buttontext = (char *) tmp;
	const char *entrytext;
	utf8_string str;

	button_equal();
	entrytext = gtk_entry_get_text(GTK_ENTRY(entry));

	try
	{
		Variable ans;

		mem.append_to_string( str, *math::intern_format );
		str.append( buttontext );
		str.append( "(" );
		str.append( entrytext );
		str.append( ")" );

		simple_intern.set_code_line( str.c_str() );
		simple_intern.calc( &ans );
		mem = *ans.get_complex();
	}
	catch(error_obj error)
	{
		GtkWidget *dialog;
		dialog = gtk_message_dialog_new( GTK_WINDOW(simplewin), GTK_DIALOG_DESTROY_WITH_PARENT,
		                                 GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE, error.msg );
		gtk_dialog_run(GTK_DIALOG(dialog));
		gtk_widget_destroy(dialog);
	}
}

gboolean simplewin_keypress( GtkWidget *widget, GdkEventKey *event, gpointer     user_data)
{
	if( event->type == GDK_KEY_PRESS )
	{
		switch( event->keyval )
		{
		case GDK_0: case GDK_KP_0:
			button0_9( 0, gpointer("0") ); break;
		case GDK_1: case GDK_KP_1:
			button0_9( 0, gpointer("1") ); break;
		case GDK_2: case GDK_KP_2:
			button0_9( 0, gpointer("2") ); break;
		case GDK_3: case GDK_KP_3:
			button0_9( 0, gpointer("3") ); break;
		case GDK_4: case GDK_KP_4:
			button0_9( 0, gpointer("4") ); break;
		case GDK_5: case GDK_KP_5:
			button0_9( 0, gpointer("5") ); break;
		case GDK_6: case GDK_KP_6:
			button0_9( 0, gpointer("6") ); break;
		case GDK_7: case GDK_KP_7:
			button0_9( 0, gpointer("7") ); break;
		case GDK_8: case GDK_KP_8:
			button0_9( 0, gpointer("8") ); break;
		case GDK_9: case GDK_KP_9:
			button0_9( 0, gpointer("9") ); break;
		case GDK_plus: case GDK_KP_Add:
			button_count( 0, gpointer("+") ); break;
		case GDK_minus: case GDK_KP_Subtract:
			button_count( 0, gpointer("-") ); break;
		case GDK_asterisk: case GDK_KP_Multiply:
			button_count( 0, gpointer("*") ); break;
		case GDK_slash: case GDK_KP_Divide:
			button_count( 0, gpointer("/") ); break;
		case GDK_percent:
			button_percent(); break;
		case GDK_comma: case GDK_period: case GDK_KP_Separator:
			button_comma(); break;
		case GDK_equal: case GDK_Return: case GDK_KP_Enter:
			button_equal(); break;
		default:
#ifdef DEVELOP
			printf("0x%X\n", event->keyval);
#endif
			break;
		}
	}
}

GtkWidget* simplewin_build_menu(void)
{
	GtkActionGroup *actions;
	GtkUIManager *ui_manager;
	GError *error = NULL;
	static const gchar *menu =
"<ui>"
"  <menubar name='MenuBar'>"
"    <menu action='FileMenu'>"
"      <menuitem action='Preferences'/>"
"      <separator/>"
"      <menuitem action='Close'/>"
"      <separator/>"
"      <menuitem action='Quit'/>"
"    </menu>"
"    <menu action='ToolsMenu'>"
"      <menuitem action='Advanced'/>"
"      <menuitem action='Editor'/>"
"      <menuitem action='Graphtool'/>"
"      <menuitem action='MatrixEdit'/>"
"    </menu>"
"    <menuitem action='About'/>"
"  </menubar>"
"</ui>";
	GtkActionEntry entries[] = {
		{ "FileMenu",    NULL,                  menu_file },
		{ "Preferences", GTK_STOCK_PREFERENCES, menu_pref,            NULL,      NULL, G_CALLBACK(prefwin_show_simple) },
		{ "Close",       GTK_STOCK_CLOSE,       menu_file_close,      "<ctrl>W", NULL, G_CALLBACK(simplewin_close) },
		{ "Quit",        GTK_STOCK_QUIT,        menu_file_quit,       "<ctrl>Q", NULL, G_CALLBACK(UMP_gtk_quit) },
		{ "ToolsMenu",   NULL,                  menu_tools },
		{ "Advanced",    NULL,                  menu_tools_advanced,  NULL,      NULL, G_CALLBACK(advancedwin_show) },
		{ "Editor",      NULL,                  menu_tools_editor,    NULL,      NULL, G_CALLBACK(editor_showwin) },
		{ "Graphtool",   NULL,                  menu_tools_graphtool, NULL,      NULL, G_CALLBACK(graphwin_show) },
		{ "MatrixEdit",  NULL,                  menu_tools_matrixedit,NULL,      NULL, G_CALLBACK(matrix_editor_show) },
		{ "About",       NULL,                  menu_about,           NULL,      NULL, G_CALLBACK(aboutwin_show_simple) }
	};
	guint n_entries = G_N_ELEMENTS(entries);

	actions = gtk_action_group_new( "Actions" );
	gtk_action_group_add_actions( actions, entries, n_entries, NULL );
	ui_manager = gtk_ui_manager_new();
	gtk_ui_manager_insert_action_group( ui_manager, actions, 0 );
	gtk_window_add_accel_group( GTK_WINDOW(simplewin),
	gtk_ui_manager_get_accel_group( ui_manager ) );
	if (!gtk_ui_manager_add_ui_from_string( ui_manager, menu, -1, &error ))
	{
		g_message( "building menus failed: %s", error->message );
		g_error_free( error );
		return 0;
	}
	gtk_ui_manager_ensure_update( ui_manager );

	return gtk_ui_manager_get_widget( ui_manager, "/MenuBar" );
}

GtkWindow* simplewin_show(void)
{
	if(simplewin == 0)
	{
		GtkWidget *tmp,*table;

		simplebrain.set_code_line( " " );
		mem = Real(0);
		showing_answer = false;
		empty_brain = true;
		count_func[0] = ' ';
		count_func[1] = '\0';

		simplewin = gtk_window_new( GTK_WINDOW_TOPLEVEL );

		gtk_window_set_title( GTK_WINDOW(simplewin), _("Ump - Simple calculator") );
		g_signal_connect_swapped( G_OBJECT(simplewin), "delete-event", G_CALLBACK(simplewin_close),
		                          NULL );

		g_signal_connect_swapped( G_OBJECT(simplewin), "key-press-event", G_CALLBACK(simplewin_keypress),
		                          NULL );

		simplewin_vbox = gtk_vbox_new( FALSE, 0 );
		gtk_container_add( GTK_CONTAINER(simplewin), simplewin_vbox);

		if( (simplewin_menu  = simplewin_build_menu()) == 0 )
		{
			gtk_widget_destroy( simplewin );
			simplewin = 0;
			return 0;
		}
		gtk_box_pack_start( GTK_BOX(simplewin_vbox), simplewin_menu, FALSE, FALSE, 0 );


		entry = gtk_entry_new();
		gtk_editable_set_editable( GTK_EDITABLE(entry), FALSE );
		gtk_entry_set_text( GTK_ENTRY(entry), "0" );
		gtk_entry_set_alignment( GTK_ENTRY(entry), 1.0f );
		g_object_set( G_OBJECT(entry), "can-focus", FALSE, NULL );
		gtk_box_pack_start( GTK_BOX(simplewin_vbox), entry, FALSE, FALSE, 0 );


		table = gtk_table_new ( 5, 7, TRUE );
		gtk_container_set_border_width( GTK_CONTAINER(table), 5 );
		gtk_table_set_row_spacings( GTK_TABLE(table), 4 );
		gtk_table_set_col_spacings( GTK_TABLE(table), 4 );
		gtk_box_pack_start( GTK_BOX(simplewin_vbox), table, TRUE, TRUE, 0 );

		tmp = gtk_button_new_with_label( "CE" );
		g_object_set( G_OBJECT(tmp), "can-focus", FALSE, NULL );
		g_signal_connect( GTK_OBJECT(tmp), "clicked", G_CALLBACK(button_CE), NULL );
		gtk_table_attach( GTK_TABLE(table), tmp, 5, 6, 0, 1, GTK_FILL, GTK_FILL, 0, 0 );

		tmp = gtk_button_new_with_label( "AC" );
		g_object_set( G_OBJECT(tmp), "can-focus", FALSE, NULL );
		g_signal_connect( GTK_OBJECT(tmp), "clicked", G_CALLBACK(button_AC), NULL );
		gtk_table_attach( GTK_TABLE(table), tmp, 6, 7, 0, 1, GTK_FILL, GTK_FILL, 0, 0 );

		tmp = gtk_button_new_with_label( "7" );
		g_object_set( G_OBJECT(tmp), "can-focus", FALSE, NULL );
		g_signal_connect( GTK_OBJECT(tmp), "clicked", G_CALLBACK(button0_9), gpointer("7") );
		gtk_table_attach( GTK_TABLE(table), tmp, 0, 1, 1, 2, GTK_FILL, GTK_FILL, 0, 0 );
		gtk_widget_set_size_request(tmp, 45, 32);

		tmp = gtk_button_new_with_label( "8" );
		g_object_set( G_OBJECT(tmp), "can-focus", FALSE, NULL );
		g_signal_connect( GTK_OBJECT(tmp), "clicked", G_CALLBACK(button0_9), gpointer("8") );
		gtk_table_attach( GTK_TABLE(table), tmp, 1, 2, 1, 2, GTK_FILL, GTK_FILL, 0, 0 );

		tmp = gtk_button_new_with_label( "9" );
		g_object_set( G_OBJECT(tmp), "can-focus", FALSE, NULL );
		g_signal_connect( GTK_OBJECT(tmp), "clicked", G_CALLBACK(button0_9), gpointer("9") );
		gtk_table_attach( GTK_TABLE(table), tmp, 2, 3, 1, 2, GTK_FILL, GTK_FILL, 0, 0 );

		tmp = gtk_button_new_with_label( "/" );
		g_object_set( G_OBJECT(tmp), "can-focus", FALSE, NULL );
		g_signal_connect( GTK_OBJECT(tmp), "clicked", G_CALLBACK(button_count), gpointer("/") );
		gtk_table_attach( GTK_TABLE (table), tmp, 3, 4, 1, 2, GTK_FILL, GTK_FILL, 0, 0 );

		tmp = gtk_button_new_with_label( "%" );
		g_object_set( G_OBJECT(tmp), "can-focus", FALSE, NULL );
		g_signal_connect( GTK_OBJECT(tmp), "clicked", G_CALLBACK(button_percent), NULL );
		gtk_table_attach( GTK_TABLE (table), tmp, 4, 5, 1, 2, GTK_FILL, GTK_FILL, 0, 0 );

		tmp = gtk_button_new_with_label( "M-" );
		g_object_set( G_OBJECT(tmp), "can-focus", FALSE, NULL );
		g_signal_connect( GTK_OBJECT(tmp), "clicked", G_CALLBACK(button_mem_calc), gpointer("-") );
		gtk_table_attach( GTK_TABLE(table), tmp, 5, 6, 1, 2, GTK_FILL, GTK_FILL, 0, 0) ;

		tmp = gtk_button_new_with_label( "MC" );
		g_object_set( G_OBJECT(tmp), "can-focus", FALSE, NULL );
		g_signal_connect( GTK_OBJECT(tmp), "clicked", G_CALLBACK(button_mem_clear), NULL );
		gtk_table_attach( GTK_TABLE(table), tmp, 6, 7, 1, 2, GTK_FILL, GTK_FILL, 0, 0 );

		tmp = gtk_button_new_with_label("4");
		g_object_set( G_OBJECT(tmp), "can-focus", FALSE, NULL );
		g_signal_connect( GTK_OBJECT(tmp), "clicked", G_CALLBACK(button0_9), gpointer("4") );
		gtk_table_attach( GTK_TABLE(table), tmp, 0, 1, 2, 3, GTK_FILL, GTK_FILL, 0, 0 );

		tmp = gtk_button_new_with_label("5");
		g_object_set( G_OBJECT(tmp), "can-focus", FALSE, NULL );
		g_signal_connect( GTK_OBJECT(tmp), "clicked", G_CALLBACK(button0_9), gpointer("5") );
		gtk_table_attach( GTK_TABLE (table), tmp, 1, 2, 2, 3, GTK_FILL, GTK_FILL, 0, 0 );

		tmp = gtk_button_new_with_label("6");
		g_object_set( G_OBJECT(tmp), "can-focus", FALSE, NULL );
		g_signal_connect( GTK_OBJECT(tmp), "clicked", G_CALLBACK(button0_9), gpointer("6") );
		gtk_table_attach( GTK_TABLE (table), tmp, 2, 3, 2, 3, GTK_FILL, GTK_FILL, 0, 0 );

		tmp = gtk_button_new_with_label("*");
		g_object_set( G_OBJECT(tmp), "can-focus", FALSE, NULL );
		g_signal_connect( GTK_OBJECT(tmp), "clicked", G_CALLBACK(button_count), gpointer("*") );
		gtk_table_attach( GTK_TABLE (table), tmp, 3, 4, 2, 3, GTK_FILL, GTK_FILL, 0, 0 );

		{
			GdkPixbuf *pixbuf;
			GtkWidget *img;
			pixbuf = gdk_pixbuf_new_from_inline (-1, image_sqrt, FALSE, NULL);

			img = gtk_image_new_from_pixbuf( pixbuf );

			tmp = gtk_button_new();
			g_object_set( G_OBJECT(tmp), "can-focus", FALSE, NULL );
			gtk_container_add( GTK_CONTAINER(tmp), img );
			g_signal_connect( GTK_OBJECT(tmp), "clicked", G_CALLBACK(button_bracket_count_before),
			                  gpointer("sqrt") );
			gtk_table_attach(GTK_TABLE (table), tmp, 4, 5, 2, 3, GTK_FILL, GTK_FILL, 0, 0 );
		}

		tmp = gtk_button_new_with_label("M+");
		g_object_set( G_OBJECT(tmp), "can-focus", FALSE, NULL );
		g_signal_connect( GTK_OBJECT(tmp), "clicked", G_CALLBACK(button_mem_calc), gpointer("+") );
		gtk_table_attach(GTK_TABLE (table), tmp, 5, 6, 2, 3, GTK_FILL, GTK_FILL, 0, 0 );

		tmp = gtk_button_new_with_label("MR");
		g_object_set( G_OBJECT(tmp), "can-focus", FALSE, NULL );
		g_signal_connect( GTK_OBJECT(tmp), "clicked", G_CALLBACK(button_mem_recall), NULL );
		gtk_table_attach( GTK_TABLE (table), tmp, 6, 7, 2, 3, GTK_FILL, GTK_FILL, 0, 0 );

		tmp = gtk_button_new_with_label("1");
		g_object_set( G_OBJECT(tmp), "can-focus", FALSE, NULL );
		g_signal_connect( GTK_OBJECT(tmp), "clicked", G_CALLBACK(button0_9), gpointer("1") );
		gtk_table_attach( GTK_TABLE(table), tmp, 0, 1, 3, 4, GTK_FILL, GTK_FILL, 0, 0 );

		tmp = gtk_button_new_with_label("2");
		g_object_set( G_OBJECT(tmp), "can-focus", FALSE, NULL );
		g_signal_connect( GTK_OBJECT(tmp), "clicked", G_CALLBACK(button0_9), gpointer("2") );
		gtk_table_attach( GTK_TABLE(table), tmp, 1, 2, 3, 4, GTK_FILL, GTK_FILL, 0, 0 );

		tmp = gtk_button_new_with_label("3");
		g_object_set( G_OBJECT(tmp), "can-focus", FALSE, NULL );
		g_signal_connect( GTK_OBJECT(tmp), "clicked", G_CALLBACK(button0_9), gpointer("3") );
		gtk_table_attach( GTK_TABLE(table), tmp, 2, 3, 3, 4, GTK_FILL, GTK_FILL, 0, 0 );

		tmp = gtk_button_new_with_label("-");
		g_object_set( G_OBJECT(tmp), "can-focus", FALSE, NULL );
		g_signal_connect( GTK_OBJECT(tmp), "clicked", G_CALLBACK(button_count), gpointer("-") );
		gtk_table_attach( GTK_TABLE(table), tmp, 3, 4, 3, 4, GTK_FILL, GTK_FILL, 0, 0 );

		tmp = gtk_button_new_with_label("x\302\262");
		g_object_set( G_OBJECT(tmp), "can-focus", FALSE, NULL );
		g_signal_connect( GTK_OBJECT(tmp), "clicked", G_CALLBACK(button_bracket_count_after),
		                  gpointer("^2") );
		gtk_table_attach( GTK_TABLE(table), tmp, 4, 5, 3, 4, GTK_FILL, GTK_FILL, 0, 0 );

		tmp = gtk_button_new_with_label("1/x");
		g_object_set( G_OBJECT(tmp), "can-focus", FALSE, NULL );
		g_signal_connect( GTK_OBJECT(tmp), "clicked", G_CALLBACK(button_bracket_count_before),
		                  gpointer("1/") );
		gtk_table_attach( GTK_TABLE(table), tmp, 5, 6, 3, 4, GTK_FILL, GTK_FILL, 0, 0 );

		tmp = gtk_button_new_with_label("x^y");
		g_object_set( G_OBJECT(tmp), "can-focus", FALSE, NULL );
		g_signal_connect( GTK_OBJECT(tmp), "clicked", G_CALLBACK(button_count), gpointer("^") );
		gtk_table_attach( GTK_TABLE(table), tmp, 6, 7, 3, 4, GTK_FILL, GTK_FILL, 0, 0 );

		tmp = gtk_button_new_with_label("0");
		g_object_set( G_OBJECT(tmp), "can-focus", FALSE, NULL );
		g_signal_connect( GTK_OBJECT(tmp), "clicked", G_CALLBACK(button0_9), gpointer("0") );
		gtk_table_attach( GTK_TABLE(table), tmp, 0, 1, 4, 5, GTK_FILL, GTK_FILL, 0, 0 );

		tmp = gtk_button_new_with_label(".");
		g_object_set( G_OBJECT(tmp), "can-focus", FALSE, NULL );
		g_signal_connect( GTK_OBJECT(tmp), "clicked", G_CALLBACK(button_comma), NULL );
		gtk_table_attach( GTK_TABLE(table), tmp, 1, 2, 4, 5, GTK_FILL, GTK_FILL, 0, 0 );

		tmp = gtk_button_new_with_label("=");
		g_object_set( G_OBJECT(tmp), "can-focus", FALSE, NULL );
		g_signal_connect( GTK_OBJECT(tmp), "clicked", G_CALLBACK(button_equal), NULL );
		gtk_table_attach( GTK_TABLE(table), tmp, 2, 3, 4, 5, GTK_FILL, GTK_FILL, 0, 0 );

		tmp = gtk_button_new_with_label("+");
		g_object_set( G_OBJECT(tmp), "can-focus", FALSE, NULL );
		g_signal_connect( GTK_OBJECT(tmp), "clicked", G_CALLBACK(button_count), gpointer("+") );
		gtk_table_attach( GTK_TABLE(table), tmp, 3, 4, 4, 5, GTK_FILL, GTK_FILL, 0, 0 );

		tmp = gtk_button_new_with_label("+/-");
		g_object_set( G_OBJECT(tmp), "can-focus", FALSE, NULL );
		g_signal_connect( GTK_OBJECT(tmp), "clicked", G_CALLBACK(button_toggle_sign), NULL );
		gtk_table_attach( GTK_TABLE(table), tmp, 4, 5, 4, 5, GTK_FILL, GTK_FILL, 0, 0 );

		tmp = gtk_button_new_with_label("Dec");
		g_object_set( G_OBJECT(tmp), "can-focus", FALSE, NULL );
		g_signal_connect( GTK_OBJECT(tmp), "clicked", G_CALLBACK(button_bracket_count_before),
		                  gpointer("dec") );
		gtk_table_attach( GTK_TABLE (table), tmp, 5, 6, 4, 5, GTK_FILL, GTK_FILL, 0, 0 );

		tmp = gtk_button_new_with_label("Frac");
		g_object_set( G_OBJECT(tmp), "can-focus", FALSE, NULL );
		g_signal_connect( GTK_OBJECT(tmp), "clicked", G_CALLBACK(button_bracket_count_before),
		                  gpointer("frac") );
		gtk_table_attach( GTK_TABLE (table), tmp, 6, 7, 4, 5, GTK_FILL, GTK_FILL, 0, 0 );

		statusbar = gtk_statusbar_new();
		gtk_box_pack_start( GTK_BOX(simplewin_vbox), statusbar, FALSE, FALSE, 0 );


		gtk_widget_show_all(simplewin);
		open_windows |= SIMPLE_WIN;
	}
	else
		gtk_window_present( GTK_WINDOW(simplewin) );

	return GTK_WINDOW(simplewin);
}


void simplewin_close(void)
{
	if(simplewin != 0)
	{
		gtk_widget_destroy(simplewin);
		simplewin = 0;

		open_windows &= ~SIMPLE_WIN;
		if(open_windows == 0)
			UMP_gtk_quit();
	}
}

void simplewin_translate(void)
{
	if(simplewin != 0)
	{
		GtkWidget *new_menu;

		if(( new_menu = simplewin_build_menu()) == 0 )
			return;

		gtk_widget_destroy( simplewin_menu );
		simplewin_menu = new_menu;

		gtk_box_pack_start(GTK_BOX(simplewin_vbox), simplewin_menu, FALSE, FALSE, 0);
		gtk_box_reorder_child( GTK_BOX(simplewin_vbox), simplewin_menu, 0 );

		gtk_window_set_title(GTK_WINDOW(simplewin), _("Ump - Simple calculator") );
	}
}
