
/*
 *  variable typedef's
 *  Copyright (c) 2002-2006 by Mattias Hultgren <mattias_hultgren@tele2.se>
 *
 *  See vartypes.h
 */

#include "vartypes.h"
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

uint32 uint64_to_char_rec( uint64 val, char *str, uint64 min_digits, uint32 digit )
{
	if( val != uint64(0) )
	{
		char tmp = '0' + char( val % uint64(10) );
		uint32 pos = uint64_to_char_rec( val/uint64(10), str, min_digits, digit+1 );
		str[pos] = tmp;
		return pos+1;
	}
	else
	{
		if( digit >= min_digits )
			return 0;
		
		uint32 pos;
		for( pos=0; pos < (min_digits-digit); pos++ )
			str[pos] = '0';
		return pos;
	}
}

void uint64_to_char( uint64 val, char *str, uint32 min_digits )
{
	min_digits = min_digits ? min_digits : 1;
	str[ uint64_to_char_rec( val, str, min_digits, 0 ) ] = '\0';
}

#ifdef DONT_HAVE_TRUNC
double trunc(double value)
{
	if( value < 0.0 )
		return -floor( -value );
	return floor( value );
}
#endif
#ifdef DONT_HAVE_LOG2
double log2(double value)
{
	return ( log( value ) / log( 2.0 ) );
}
#endif

#if defined USE_FLOAT  ||  USE_DOUBLE
	extern const floatx PI = M_PI;
	extern const floatx E = M_E;
#endif
#ifdef USE_LONG_DOUBLE
	#ifdef M_PIl
		const floatx PI = M_PIl;
	#else
		const floatx PI = M_PI;
	#endif
	#ifdef M_El
		const floatx E = M_El;
	#else
		const floatx E = M_E;
	#endif
#endif

class vartypes_check
{
public:
	vartypes_check();

}check;

vartypes_check::vartypes_check()
{
	if(sizeof(int8) != 1)
	{
		printf("The int8 isn't 8 bits as it should, please correct it in file vartypes.h\n");
		exit(-1);
	}

	if(sizeof(int16) != 2)
	{
		printf("The int16 isn't 16 bits as it should, please correct it in file vartypes.h\n");
		exit(-1);
	}

	if(sizeof(int32) != 4)
	{
		printf("The int32 isn't 32 bits as it should, please correct it in file vartypes.h\n");
		exit(-1);
	}

	if(sizeof(int64) != 8)
	{
		printf("The int64 isn't 64 bits as it should, please correct it in file vartypes.h\n");
		exit(-1);
	}
}
